	.module TinyLCD_Controller.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\docs\SMARTL~1\SMARTL~1\SmartLCD\SMARTL~1\TinyLCD_Controller.c
	.area lit(rom, con, rel)
_signon1::
	.byte 10,13,10,13,'L,'E,'D,56,32,'M,'o,'n,'i,'t,'o,'r
	.byte 32,'V,48,46,56,54,10,13,0
	.dbsym e signon1 _signon1 A[25:25]kc
_line1chars::
	.byte 'S,'m
	.byte 'a,'r
	.byte 't,'L
	.byte 'C,'D
	.byte 32,32
	.byte 32,32
	.byte 0
	.dbsym e line1chars _line1chars A[13:13]kc
_line2chars::
	.byte 'V,'e
	.byte 'r,'s
	.byte 'i,'o
	.byte 'n,32
	.byte 49,46
	.byte 48,48
	.byte 0
	.dbsym e line2chars _line2chars A[13:13]kc
_line3chars::
	.byte 'S,'O
	.byte 'C,32
	.byte 'R,'o
	.byte 'b,'o
	.byte 't,'i
	.byte 'c,'s
	.byte 0
	.dbsym e line3chars _line3chars A[13:13]kc
_line4chars::
	.byte 'w,'a
	.byte 'i,'t
	.byte 'i,'n
	.byte 'g,32
	.byte 32,32
	.byte 32,32
	.byte 0
	.dbsym e line4chars _line4chars A[13:13]kc
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\docs\SMARTL~1\SMARTL~1\SmartLCD\SMARTL~1\TinyLCD_Controller.c
	.dbfunc e bytetoint _bytetoint fV
;           ones -> R20
;           tens -> R22
;           byte -> R10
	.even
_bytetoint::
	xcall push_xgsetF00C
	mov R10,R16
	.dbline -1
	.dbline 296
; /**************************************************************
; 
;    Program Title:  TinyLCD Controller
;    
;    Program Name:  TinyLCD_Controller.c	  Version: 0.87
;    
;    Author:  SS	  					  Date:  April 10, 2006
;    
;   This program monitors data on SCL/SDA or UART and writes it to the ECMA1007
;   LCD panel. A simple command structure is used to write text to the 
;   screen.  The LCD panel is addressed by comparing addresses stored 
;   in EEPROM with commands sent on the 2-Wire line.
;   
;   The TinyLCD7 PCB has pads for a xtal or clock osc for real time
;   clock or precision operation.
;   
;   The TinyLCD7 PCB also has a pad for the ST Electronics three axis 
;   programmable accelerometer.
;   
;   I2C default address is:  0x25
;   
;   Pin assignments:
;     PC4  Pin 1 - SDA
;     PC5  Pin 3 - SCL
;     PC3  Pin 20 - SCL ECMA1007 
;     PC2  Pin 11 - SI ECMA1007
;     PB1  Pin 4 - CS ECMA1007
;     PB2  Pin 8 - LA0 ECMA1007
;     PB0  Pin 7 - RESET ECMA1007
; 
;   Settings can be stored in EEPROM for later recall at power up.
; 
;   EEPROM Settings:
;      Address    Default    Function
;        0x00       0x01      Address of Controller - 1-256, 0 broadcast
;        0x05       0x00      Oscillator calibrated - 0 - No
;        0x06       0x00      Oscillator calibration value
;        0x07       0x00      
; 
;   2-Wire Commands:  Commands are sent to the display controller using
;   a TWI protocol.  Wakeup address and selection addresses are stored
;   in EEPROM and can be changed.
; 
;      Command      Function
;        DAC        display character at address A
;        DC         Display character at current cursor location
;        C          Clear screen
;        S          Scroll up one line
;        NA         New selection address
;        WA         Wakeup address
;        H          Turn IR High power on
; 
;    Fuse settings should be:  F9 DF E2
;    
;    Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2006, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: TinyLCD_Controller.c,v $
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, Serial Flash writer, XON/XOFF, 9,600baud
;  *    real time clock and auto-internal osc calibration.
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  * 
;  */ 
; #include <iom168v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <math.h>
; //#include <stdio.h>
; #include "TinyLCD_Uart.h"
; #include "TinyLCD_Defines.h"
; #include "TinyLCD_Extern.h"
; #include "USI_TWI_Slave.h"
; 
; //  Variable declarations
; unsigned int intelsuperaddress,oldpage,oldbyteoffset,totalrxcnt;
; unsigned int rtccountdown1,rtccountdown2,rtccountdown3,rtccountdown4;
; unsigned int mseccountdown1,mseccountdown2,mseccountdown3,mseccountdown4;
; unsigned int mseccountdown5;
; unsigned int seconds,minutes,hours,days,count;
; 
; unsigned int totalbytecnt,xoncnt,xoffcnt;
; unsigned char frameerror,dataoverrun,numstrg[9],lcdchiptype;
; unsigned char lcdstate,rtcclockcnt;
; char key1state,key2state,key3state,key4state;
; char key1toggle,key2toggle,key3toggle,key4toggle;
; 
; extern int _textmode;
; 
; /* Static Variables */
; unsigned char UART_RxBuf[UART_RX_BUFFER_SIZE];
; unsigned char UART_RxHead;
; unsigned char UART_RxTail;
; unsigned char UART_TxBuf[UART_TX_BUFFER_SIZE];
; unsigned char UART_TxHead;
; unsigned char UART_TxTail;
; char  xoffsent, xonsent, enablexonoff, echoinchars,sendxoff;
; char  rxcnt,checkflag,rxcntmax,flip2;
; unsigned char  instrg[8],vlow,vhigh,hexbyte[3];
; 
; unsigned char FlashAddress[3];
; const char signon1[] = "\n\r\n\rLED8 Monitor V0.86\n\r";
; 
; // Function declarations
; unsigned char EEPROMwrite(int,unsigned char);
; unsigned char EEPROMread(int);
; 
; // Sample TWI transmission commands
; #define TWI_CMD_MASTER_WRITE 0x00
; #define TWI_CMD_MASTER_READ  0x01
; 
; // TBD - how many bytes can be transmitted per 2-wire operation?
; #define MESSAGEBUF_SIZE       4
; 
; //  Set default slave address
; #define    TWI_SLAVEADDRESS		 0x15
; 
; // Clear display - move cursor to home
; #define    LCDCLR	0x01
; 
; // E1010 and E1007 Commands
; #define	   LCDCHIPE1010 0x10
; #define    LCDCHIPE1007 0x07   
; 
; // move cursor to home position command
; #define    LCDHOME   	0x10  
; 
; // Static Display Command
; //   D1/0 - 0,0  Display OFF
; //   D1/0 - 0,1  1-2Hz blink
; //   D1/0 - 1,0  3-4Hz blink
; //   D1/0 - 1,1  Display ON
; #define    LCDSTATICDISPLAY	0x20 
; #define    LCDDISPLAYON  	0x03
; #define    LCDDISPLAYOFF	0x00 
; 
; // Display control command
; //   D3-C, D2-B, D1-DC, D0-D
; //   C  -> 1 cursor on, 0 off
; //   DC -> 1 double cursor on, 0 off
; //   B  -> 1 blink on, 0 off
; //   D  -> 1 display on, 0 off	 
; #define    LCDDISPLAY          0x30 
; #define    LCDCURSORON	       0x08
; #define    LCDCURSOROFF        0x00
; #define    LCDCURSORBLINK      0x04 
; #define    LCDCURSONNOBLINK    0x00
; #define    LCDCURSORDISPLAYON  0x01
; #define    LCDCURSORDISPLAYOFF 0x00
; 
; // Power Save Command
; //   D1-O, D0-PS
; //   PS -> 1 power save on, 0 off
; //   O  -> 1 oscillator circuit on, 0 off
; #define	   LCDPOWERSAVE    0x40
; #define    LCDPOWERSAVEON  0x01
; #define    LCDPOWERSAVEOFF 0x00
; #define    LCDOSCON		   0x02
; #define    LCDOSCOFF	   0x00
; 
; // Power supply control
; //   D2-VC, D1-VF, D0-P
; //   VC -> 1 voltage regulator on, 0 off
; //   VF -> 1 voltage follower on, 0 off
; //   P  -> 1 voltage booster on, 0 off
; #define    LCDPOWERSUPPLY   0x50
; #define	   LCDVOLTREGON     0x04
; #define	   LCDVOLTREGOFF    0x00
; #define	   LCDVOLTFOLLOWON  0x02
; #define	   LCDVOLTFOLLOWOFF 0x00
; #define	   LCDVOLTBOOSTON   0x01
; #define	   LCDVOLTBOOSTOFF  0x00
; 
; // System set command
; //   D3-N2, D2-N1, D0-CG
; //   N2/1 -> 0,0  2 lines
; //   N2/1 -> 0,1  3 lines
; //   N2/1 -> 1,0  4 lines
; //   CG   -> 1 CGRAM used, 0 not used
; #define    LCDSYSTEMSET  0x60
; #define    LCD4LINE		 0x08
; #define    LCDCGON		 0x01
; 
; // Electronic volume setting
; //   D3-0 - set display brightness
; #define    LCDVOLREG 0x70  
; 
; // Set address of DDRAM, CGRAM or symbol register
; #define    LCDRAMADDRESS  0x80 
; 
; //  LCD chip select is active low
; #define	   CS       1
; //  LCD Command/Data  0 - command, 1 data
; #define    LA0      2
; //  LCD reset line - active high to reset
; #define    LCDRESET 0
; //  LCD Serial Data Line
; #define    LCD_SI   2
; //  LCD Serial Clock
; #define    LCD_SCLK 3
; 
; #define    LCDCONTROL PORTB
; #define    LCDDATA    PORTC
; #define    LINE1 	  0x30
; #define	   LINE2	  0x40
; #define	   LINE3	  0x50
; #define	   LINE4	  0x60
; 
; #define    TAB		  0x09
; #define    CRLF       0x10
; #define    TITLE      0x01
; 
; // LCD defines
; #define  LCD_BATTERY_FULL    6
; #define  LCD_BATTERY_THREEQUARTER 5 
; #define  LCD_BATTERY_HALF    4
; #define  LCD_BATTERY_QUARTER 3
; #define  LCD_BATTERY_EMPTY   2
; #define  LCD_BATTERY_OFF     1
; 
; #define  LCD_ANTENNA_FULL    6
; #define  LCD_ANTENNA_THREEQUARTER  5
; #define  LCD_ANTENNA_HALF    4
; #define  LCD_ANTENNA_QUARTER 3 
; #define  LCD_ANTENNA_EMPTY   2
; #define  LCD_ANTENNA_OFF     1
; 
; #define  LCD_PHONE_ON		 1
; #define  LCD_SLASHPHONE		 2
; #define  LCD_PHONE_OFF		 3
; 
; #define  LCD_PHONE_SYMBOL      0x02
; #define  LCD_BIGANTENNA_SYMBOL 0x08
; 
; #define  NO_ACTIVE_STATE 0
; #define  ANTENNA_STATE  1
; #define  BATTERY_STATE  2
; #define  VSYM_STATE     3
; #define  DSYM_STATE     4
; #define  RSYM_STATE     5
; #define  ENVELOPE_STATE 6
; #define  PHONE_STATE    7
; #define  TWI_ADDRESS_STATE 8
; #define  LCD_SYMBOL_STATE 9
; #define  LED_BLINK_STATE 10
; #define  VOLTAGE_STATE  11
; 
; const unsigned char line1chars[] = {'S','m','a','r','t','L','C','D',' ',' ',' ',' ',0x00};
; const unsigned char line2chars[] = {'V','e','r','s','i','o','n',' ','1','.','0','0',0x00};
; const unsigned char line3chars[] = {'S','O','C',' ','R','o','b','o','t','i','c','s',0x00};
; const unsigned char line4chars[] = {'w','a','i','t','i','n','g',' ',' ',' ',' ',' ',0x00};
; unsigned char line1[13],line2[13],line3[13],line4[13];
; unsigned char cursorposition,cursormax,rowptr,colptr,lineptr,escmode;
; unsigned char lcdphoneantennasymbols,lcdstate,symbolmode,voltagevolume;
; 
; extern struct TWI_S_statusReg TWI_statusReg;
; 
; void bytetoint(unsigned char byte)
; {
	.dbline 299
;  	 unsigned char tens,ones;
; 	 
; 	 tens = byte/10;
	ldi R17,10
	mov R16,R10
	xcall div8u
	mov R22,R16
	.dbline 300
; 	 ones = byte%10;
	ldi R17,10
	mov R16,R10
	xcall mod8u
	mov R20,R16
	.dbline 301
; 	 hexbyte[0] = tens + '0';
	mov R24,R22
	subi R24,208    ; addi 48
	sts _hexbyte,R24
	.dbline 302
; 	 hexbyte[1] = ones + '0';
	mov R24,R20
	subi R24,208    ; addi 48
	sts _hexbyte+1,R24
	.dbline 303
; 	 hexbyte[2] = 0x00;
	clr R2
	sts _hexbyte+2,R2
	.dbline -2
L1:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym r ones 20 c
	.dbsym r tens 22 c
	.dbsym r byte 10 c
	.dbend
	.dbfunc e LCDWriteSerialByte _LCDWriteSerialByte fV
;           mask -> R20
;              i -> R22
;         inchar -> R16
	.even
_LCDWriteSerialByte::
	st -y,R20
	st -y,R22
	.dbline -1
	.dbline 307
; }
; 
; void   LCDWriteSerialByte(unsigned char inchar)
; {
	.dbline 310
;  	unsigned char i,mask;
; 
; 	mask = 0x80;
	ldi R20,128
	.dbline 311
; 	for(i=0; i<8; i++) {
	clr R22
	xjmp L8
L5:
	.dbline 311
	.dbline 312
; 	    ClrBit(LCDDATA,LCD_SCLK);
	cbi 0x8,3
	.dbline 313
; 		if((inchar&mask)) SetBit(LCDDATA,LCD_SI);
	mov R2,R16
	and R2,R20
	breq L9
X0:
	.dbline 313
	sbi 0x8,2
	xjmp L10
L9:
	.dbline 314
; 		else ClrBit(LCDDATA,LCD_SI);
	cbi 0x8,2
L10:
	.dbline 315
; 		mask >>= 1;
	lsr R20
	.dbline 316
; 		SetBit(LCDDATA,LCD_SCLK);
	sbi 0x8,3
	.dbline 317
; 	    }
L6:
	.dbline 311
	inc R22
L8:
	.dbline 311
	cpi R22,8
	brlo L5
X1:
	.dbline -2
L4:
	.dbline 0 ; func end
	ld R22,y+
	ld R20,y+
	ret
	.dbsym r mask 20 c
	.dbsym r i 22 c
	.dbsym r inchar 16 c
	.dbend
	.dbfunc e LCDprintchar _LCDprintchar fV
;         inchar -> R10
	.even
_LCDprintchar::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 321
; }
; 
; void   LCDprintchar(unsigned char inchar)
; {
	.dbline 322
; 	LCDCONTROL |= BIT(LA0); // raise A0 high
	sbi 0x5,2
	.dbline 323
; 	LCDCONTROL &= ~BIT(CS); // set CS low
	cbi 0x5,1
	.dbline 324
; 	ShortDelay(1);
	ldi R16,1
	ldi R17,0
	xcall _ShortDelay
	.dbline 325
; 	LCDWriteSerialByte(inchar);
	mov R16,R10
	xcall _LCDWriteSerialByte
	.dbline 326
; 	LCDCONTROL |= BIT(CS); // release CS
	sbi 0x5,1
	.dbline 327
; 	ShortDelay(2);	
	ldi R16,2
	ldi R17,0
	xcall _ShortDelay
	.dbline -2
L11:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e LCDwritecommand _LCDwritecommand fV
;         inchar -> R10
	.even
_LCDwritecommand::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 331
; }
; 
; void   LCDwritecommand(unsigned char inchar)
; { 		
	.dbline 332
; 	LCDCONTROL &= ~BIT(LA0); /* set A0 low */
	cbi 0x5,2
	.dbline 333
; 	LCDCONTROL &= ~BIT(CS);  /* set RS low */
	cbi 0x5,1
	.dbline 334
; 	ShortDelay(1);
	ldi R16,1
	ldi R17,0
	xcall _ShortDelay
	.dbline 335
; 	LCDWriteSerialByte(inchar);
	mov R16,R10
	xcall _LCDWriteSerialByte
	.dbline 336
; 	LCDCONTROL |= BIT(CS); // release CS
	sbi 0x5,1
	.dbline 337
; 	ShortDelay(2);
	ldi R16,2
	ldi R17,0
	xcall _ShortDelay
	.dbline -2
L12:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e LCDDisplayChar _LCDDisplayChar fV
;         inchar -> R10
;        address -> R20
	.even
_LCDDisplayChar::
	st -y,R10
	st -y,R20
	mov R10,R18
	mov R20,R16
	.dbline -1
	.dbline 341
; }
; 
; void   LCDDisplayChar(unsigned char address, unsigned char inchar)
; {
	.dbline 342
;  	LCDwritecommand(LCDRAMADDRESS|address);
	mov R16,R20
	ori R16,128
	xcall _LCDwritecommand
	.dbline 343
; 	LCDprintchar(inchar);
	mov R16,R10
	xcall _LCDprintchar
	.dbline -2
L13:
	.dbline 0 ; func end
	ld R20,y+
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbsym r address 20 c
	.dbend
	.dbfunc e LCD_Write _LCD_Write fV
;           data -> R10
;        address -> R20
	.even
_LCD_Write::
	st -y,R10
	st -y,R20
	mov R10,R18
	mov R20,R16
	.dbline -1
	.dbline 347
; }
; 
; void LCD_Write(unsigned char address,unsigned char data)
; {
	.dbline 348
; 	LCDwritecommand(LCDRAMADDRESS|address);
	mov R16,R20
	ori R16,128
	xcall _LCDwritecommand
	.dbline 349
; 	LCDprintchar(data);
	mov R16,R10
	xcall _LCDprintchar
	.dbline -2
L14:
	.dbline 0 ; func end
	ld R20,y+
	ld R10,y+
	ret
	.dbsym r data 10 c
	.dbsym r address 20 c
	.dbend
	.dbfunc e LCDdisplays _LCDdisplays fV
;              j -> <dead>
;              i -> R20
;         instrg -> R10,R11
;        address -> R22
	.even
_LCDdisplays::
	xcall push_xgsetF00C
	movw R10,R18
	mov R22,R16
	.dbline -1
	.dbline 353
; }
; 
; void   LCDdisplays(unsigned char address, char *instrg)
; {
	.dbline 356
; 	char i,j;
; 
; 	i = 0;
	clr R20
	.dbline 357
; 	LCDwritecommand(LCDRAMADDRESS|address);
	mov R16,R22
	ori R16,128
	xcall _LCDwritecommand
	xjmp L17
L16:
	.dbline 358
; 	while(instrg[i]!=0x00) LCDprintchar(instrg[i++]);
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	mov R30,R2
	clr R31
	add R30,R10
	adc R31,R11
	ldd R16,z+0
	xcall _LCDprintchar
L17:
	.dbline 358
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	tst R2
	brne L16
X2:
	.dbline -2
L15:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym l j 1 c
	.dbsym r i 20 c
	.dbsym r instrg 10 pc
	.dbsym r address 22 c
	.dbend
	.dbfunc e LCDprints _LCDprints fV
;              j -> R22
;              i -> R20
;         instrg -> R10,R11
	.even
_LCDprints::
	xcall push_xgsetF00C
	movw R10,R16
	.dbline -1
	.dbline 362
; }
; 
; void   LCDprints(char *instrg)
; {
	.dbline 365
; 	char i,j;
; 
; 	i = 0;
	clr R20
	xjmp L21
L20:
	.dbline 366
; 	while(instrg[i]!=0x00) {
	.dbline 367
; 		if(cursorposition>=cursormax) {
	lds R2,_cursormax
	lds R3,_cursorposition
	cp R3,R2
	brlo L23
X3:
	.dbline 367
	.dbline 368
; 		   cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 369
; 		   return ; // or wrap line
	xjmp L19
L23:
	.dbline 371
; 		   }
; 		else  {
	.dbline 372
; 			  if(instrg[i]==LF) LCDwritecommand(LCDCLR);
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R24,z+0
	cpi R24,10
	brne L25
X4:
	.dbline 372
	ldi R16,1
	xcall _LCDwritecommand
	xjmp L26
L25:
	.dbline 373
; 			  else if(instrg[i]==CR) LCDwritecommand(LCDHOME);
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R24,z+0
	cpi R24,13
	brne L27
X5:
	.dbline 373
	ldi R16,16
	xcall _LCDwritecommand
	xjmp L28
L27:
	.dbline 374
; 			  else if(instrg[i]==TAB) for(j=0; j<6; j++) LCDprintchar(0x20);
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R24,z+0
	cpi R24,9
	brne L29
X6:
	.dbline 374
	clr R22
	xjmp L34
L31:
	.dbline 374
	ldi R16,32
	xcall _LCDprintchar
L32:
	.dbline 374
	inc R22
L34:
	.dbline 374
	cpi R22,6
	brlo L31
X7:
	xjmp L30
L29:
	.dbline 375
; 			  else LCDprintchar(instrg[i++]);
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	mov R30,R2
	clr R31
	add R30,R10
	adc R31,R11
	ldd R16,z+0
	xcall _LCDprintchar
L30:
L28:
L26:
	.dbline 376
; 			  cursorposition++;
	lds R24,_cursorposition
	subi R24,255    ; addi 1
	sts _cursorposition,R24
	.dbline 377
; 			  }
	.dbline 378
; 		}
L21:
	.dbline 366
	mov R30,R20
	clr R31
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	tst R2
	breq X9
	xjmp L20
X9:
X8:
	.dbline -2
L19:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym r j 22 c
	.dbsym r i 20 c
	.dbsym r instrg 10 pc
	.dbend
	.dbfunc e LCD_Symbols _LCD_Symbols fV
;              i -> R20,R21
;          state -> R22
	.even
_LCD_Symbols::
	xcall push_xgsetF000
	mov R22,R16
	.dbline -1
	.dbline 382
; }
; 
; void LCD_Symbols(unsigned char state)
; { 	 
	.dbline 385
; 	 int i;
; 	 
; 	 if(state==ON) {
	cpi R22,1
	brne L36
X10:
	.dbline 385
	.dbline 386
; 	 	 LCDwritecommand(LCDRAMADDRESS|0x70);
	ldi R16,240
	xcall _LCDwritecommand
	.dbline 387
; 	 	 for(i=0; i<12; i++)  LCDprintchar(0x0b);
	clr R20
	clr R21
L38:
	.dbline 387
	ldi R16,11
	xcall _LCDprintchar
L39:
	.dbline 387
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 387
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L38
X11:
	.dbline 388
; 		 }
	xjmp L37
L36:
	.dbline 389
; 	 else if(state==OFF) {
	tst R22
	brne L42
X12:
	.dbline 389
	.dbline 390
; 	 	 LCDwritecommand(LCDRAMADDRESS|0x70);
	ldi R16,240
	xcall _LCDwritecommand
	.dbline 391
; 	 	 for(i=0; i<12; i++)  LCDprintchar(0x00);
	clr R20
	clr R21
L44:
	.dbline 391
	clr R16
	xcall _LCDprintchar
L45:
	.dbline 391
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 391
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L44
X13:
	.dbline 392
; 		 }
L42:
L37:
	.dbline -2
L35:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r i 20 I
	.dbsym r state 22 c
	.dbend
	.dbfunc e SetBuffers _SetBuffers fV
;              i -> R20
;         inchar -> R16
	.even
_SetBuffers::
	st -y,R20
	.dbline -1
	.dbline 396
; }
; 
; void SetBuffers(unsigned char inchar)
; {
	.dbline 399
;  	 unsigned char i;
; 	 
; 	 for(i=0; i<12; i++) {
	clr R20
	xjmp L52
L49:
	.dbline 399
	.dbline 400
; 	     line1[i] = inchar;
	ldi R24,<_line1
	ldi R25,>_line1
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 401
; 		 line2[i] = inchar;
	ldi R24,<_line2
	ldi R25,>_line2
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 402
; 		 line3[i] = inchar;
	ldi R24,<_line3
	ldi R25,>_line3
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 403
; 		 line4[i] = inchar;
	ldi R24,<_line4
	ldi R25,>_line4
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 404
; 		 }
L50:
	.dbline 399
	inc R20
L52:
	.dbline 399
	cpi R20,12
	brlo L49
X14:
	.dbline -2
L48:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbsym r inchar 16 c
	.dbend
	.dbfunc e Clear_LCD _Clear_LCD fV
;              i -> R20,R21
	.even
_Clear_LCD::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 408
; }
; 
; void Clear_LCD()
; {
	.dbline 412
;  	 int i;
; 	 
; 	 // Clear 4x12 display
; 	 for(i=0; i<12; i++) LCD_Write(LCDRAMADDRESS|0x30+i,' ');
	clr R20
	clr R21
L54:
	.dbline 412
	ldi R18,32
	mov R16,R20
	subi R16,208  ; offset = 48
	sbci R17,255
	ori R16,128
	xcall _LCD_Write
L55:
	.dbline 412
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 412
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L54
X15:
	.dbline 413
; 	 for(i=0; i<12; i++) LCD_Write(LCDRAMADDRESS|0x40+i,' ');
	clr R20
	clr R21
L58:
	.dbline 413
	ldi R18,32
	mov R16,R20
	subi R16,192  ; offset = 64
	sbci R17,255
	ori R16,128
	xcall _LCD_Write
L59:
	.dbline 413
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 413
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L58
X16:
	.dbline 414
; 	 for(i=0; i<12; i++) LCD_Write(LCDRAMADDRESS|0x50+i,' ');
	clr R20
	clr R21
L62:
	.dbline 414
	ldi R18,32
	mov R16,R20
	subi R16,176  ; offset = 80
	sbci R17,255
	ori R16,128
	xcall _LCD_Write
L63:
	.dbline 414
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 414
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L62
X17:
	.dbline 415
; 	 for(i=0; i<12; i++) LCD_Write(LCDRAMADDRESS|0x60+i,' ');
	clr R20
	clr R21
L66:
	.dbline 415
	ldi R18,32
	mov R16,R20
	subi R16,160  ; offset = 96
	sbci R17,255
	ori R16,128
	xcall _LCD_Write
L67:
	.dbline 415
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 415
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	brlt L66
X18:
	.dbline 418
; 	 
; 	 // Clear buffers
; 	 SetBuffers(' ');
	ldi R16,32
	xcall _SetBuffers
	.dbline 421
; 	 
; 	 // Clear all symbols
; 	 LCD_Symbols(OFF);
	clr R16
	xcall _LCD_Symbols
	.dbline -2
L53:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r i 20 I
	.dbend
	.dbfunc e Init_LCD _Init_LCD fV
	.even
_Init_LCD::
	.dbline -1
	.dbline 432
; }
; 
; 
; /******************************************
;   LCD interface control logic:
;        CS -  0 select device
;        R/W - 0 WR, 1 RD,
;        LA0 - 0 command, 1 data
;  ******************************************/
; void Init_LCD()
; {
	.dbline 433
;      lcdchiptype = LCDCHIPE1007;  // if lcd display is E1007
	ldi R24,7
	sts _lcdchiptype,R24
	.dbline 435
; 	 
; 	 SetBit(PORTB,PINB6);  // set clock high
	sbi 0x5,6
	.dbline 437
; 	 // Reset LCD - hold in reset for 10usec
; 	 LCDCONTROL &= ~BIT(LCDRESET);  // Set Reset line low
	cbi 0x5,0
	.dbline 438
; 	 ShortDelay(200);
	ldi R16,200
	ldi R17,0
	xcall _ShortDelay
	.dbline 439
; 	 LCDCONTROL |= BIT(LCDRESET);  // Set Reset line high
	sbi 0x5,0
	.dbline 440
; 	 ShortDelay(50);
	ldi R16,50
	ldi R17,0
	xcall _ShortDelay
	.dbline 451
; 	
; 	// Static Icon off - display on - RF circuit on - clear RAM
; 	// Set display volume
; 
; // System set command
; //   D3-N2, D2-N1, D0-CG
; //   N2/1 -> 0,0  2 lines
; //   N2/1 -> 0,1  3 lines
; //   N2/1 -> 1,0  4 lines
; //   CG   -> 1 CGRAM used, 0 not used
;      LCDwritecommand(LCDSYSTEMSET|LCD4LINE|LCDCGON);
	ldi R16,105
	xcall _LCDwritecommand
	.dbline 458
; 
; // Static Display Command
; //   D1/0 - 0,0  Display OFF
; //   D1/0 - 0,1  1-2Hz blink
; //   D1/0 - 1,0  3-4Hz blink
; //   D1/0 - 1,1  Display ON
; 	 LCDwritecommand(LCDSTATICDISPLAY|LCDDISPLAYON);
	ldi R16,35
	xcall _LCDwritecommand
	.dbline 467
; 	 
; // Display control command
; //   D3-C, D2-B, D1-DC, D0-D
; //   C  -> 1 cursor on, 0 off
; //   DC -> 1 double cursor on, 0 off
; //   B  -> 1 blink on, 0 off
; //   D  -> 1 display on, 0 off	 
; //	 LCDwritecommand(LCDDISPLAY|LCDCURSORON|LCDCURSORBLINK|LCDCURSORDISPLAYON);
; 	 LCDwritecommand(LCDDISPLAY|LCDCURSORDISPLAYON);
	ldi R16,49
	xcall _LCDwritecommand
	.dbline 473
; 
; // Power Save Command
; //   D1-PS, D0-O
; //   PS -> 1 power save on, 0 off
; //   O  -> 1 oscillator circuit on, 0 off
;      LCDwritecommand(LCDPOWERSAVE|LCDPOWERSAVEOFF|LCDOSCON);
	ldi R16,66
	xcall _LCDwritecommand
	.dbline 476
; 
; 	 // Set data pointer to DDRAM
; 	 LCDwritecommand(LCDRAMADDRESS|0x30);
	ldi R16,176
	xcall _LCDwritecommand
	.dbline 479
; 
; 	 // Wait 20ms for power supply to stabilize
; 	 ShortDelay(30000);	 
	ldi R16,30000
	ldi R17,117
	xcall _ShortDelay
	.dbline 486
; 
; 	 // Power supply control
; 	 //   D2-VC, D1-VF, D0-P
; 	 //   VC -> 1 voltage regulator on, 0 off
; 	 //   VF -> 1 voltage follower on, 0 off
; 	 //   P  -> 1 voltage booster on, 0 off
; 	 LCDwritecommand(LCDPOWERSUPPLY|LCDVOLTREGON|LCDVOLTFOLLOWON|LCDVOLTBOOSTON);
	ldi R16,87
	xcall _LCDwritecommand
	.dbline 492
; //	 LCDwritecommand(LCDPOWERSUPPLY|LCDVOLTREGON|LCDVOLTFOLLOWON);
; 
; 	 // Electronic volume setting
; 	 //   D3-0 - set display brightness
; 	 // TBD - real VDD and adjust Voltage Volume accordingly
; 	 voltagevolume = 0x09;
	ldi R24,9
	sts _voltagevolume,R24
	.dbline 493
;      LCDwritecommand(LCDVOLREG|voltagevolume); 
	mov R16,R24
	ori R16,112
	xcall _LCDwritecommand
	.dbline 496
; 
; 	 // move cursor to home position command
; 	 LCDwritecommand(LCDHOME); 
	ldi R16,16
	xcall _LCDwritecommand
	.dbline 498
;  
;  	 lcdphoneantennasymbols = 0;
	clr R2
	sts _lcdphoneantennasymbols,R2
	.dbline 499
; 	 cursormax = 12;
	ldi R24,12
	sts _cursormax,R24
	.dbline 500
; 	 cursorposition = 0;
	sts _cursorposition,R2
	.dbline 501
; 	 rowptr = 1;
	ldi R24,1
	sts _rowptr,R24
	.dbline 502
; 	 colptr = 0;
	sts _colptr,R2
	.dbline 503
; 	 lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 504
; 	 lcdstate = NO_ACTIVE_STATE;
	sts _lcdstate,R2
	.dbline 505
; 	 symbolmode = NO_ACTIVE_STATE;
	sts _symbolmode,R2
	.dbline -2
L70:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisplayLCDBuffers _DisplayLCDBuffers fV
	.even
_DisplayLCDBuffers::
	.dbline -1
	.dbline 509
; }
; 
; void DisplayLCDBuffers()
; {
	.dbline 510
; 	 LCDdisplays(LINE1,line1);
	ldi R18,<_line1
	ldi R19,>_line1
	ldi R16,48
	xcall _LCDdisplays
	.dbline 511
;    	 LCDdisplays(LINE2,line2);
	ldi R18,<_line2
	ldi R19,>_line2
	ldi R16,64
	xcall _LCDdisplays
	.dbline 512
;    	 LCDdisplays(LINE3,line3);
	ldi R18,<_line3
	ldi R19,>_line3
	ldi R16,80
	xcall _LCDdisplays
	.dbline 513
;    	 LCDdisplays(LINE4,line4);	 
	ldi R18,<_line4
	ldi R19,>_line4
	ldi R16,96
	xcall _LCDdisplays
	.dbline -2
L71:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LoadSignon _LoadSignon fV
;              i -> <dead>
	.even
_LoadSignon::
	.dbline -1
	.dbline 517
; }
; 
; void LoadSignon()
; {
	.dbline 520
;  	 unsigned char i;
; 	 
; 	 cstrcpy(line1,line1chars);
	ldi R18,<_line1chars
	ldi R19,>_line1chars
	ldi R16,<_line1
	ldi R17,>_line1
	xcall _cstrcpy
	.dbline 521
; 	 cstrcpy(line2,line2chars);
	ldi R18,<_line2chars
	ldi R19,>_line2chars
	ldi R16,<_line2
	ldi R17,>_line2
	xcall _cstrcpy
	.dbline 522
; 	 cstrcpy(line3,line3chars);
	ldi R18,<_line3chars
	ldi R19,>_line3chars
	ldi R16,<_line3
	ldi R17,>_line3
	xcall _cstrcpy
	.dbline 523
; 	 cstrcpy(line4,line4chars);
	ldi R18,<_line4chars
	ldi R19,>_line4chars
	ldi R16,<_line4
	ldi R17,>_line4
	xcall _cstrcpy
	.dbline -2
L72:
	.dbline 0 ; func end
	ret
	.dbsym l i 1 c
	.dbend
	.dbfunc e ShiftUpLine _ShiftUpLine fV
;              i -> R20
	.even
_ShiftUpLine::
	st -y,R20
	.dbline -1
	.dbline 527
; }
; 
; void ShiftUpLine()
; {
	.dbline 530
;  	 unsigned char i;
; 	 
; 	 for(i=0; i<12; i++) {
	clr R20
	xjmp L77
L74:
	.dbline 530
	.dbline 531
; 	     line1[i] = line2[i];
	ldi R24,<_line2
	ldi R25,>_line2
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_line1
	ldi R25,>_line1
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 532
; 		 line2[i] = line3[i];
	ldi R24,<_line3
	ldi R25,>_line3
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_line2
	ldi R25,>_line2
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 533
; 		 line3[i] = line4[i];
	ldi R24,<_line4
	ldi R25,>_line4
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,<_line3
	ldi R25,>_line3
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R2
	.dbline 534
; 		 line4[i] = ' ';
	ldi R24,<_line4
	ldi R25,>_line4
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldi R24,32
	std z+0,R24
	.dbline 535
; 		 }
L75:
	.dbline 530
	inc R20
L77:
	.dbline 530
	cpi R20,12
	brsh X20
	xjmp L74
X20:
X19:
	.dbline 536
;      DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 537
; 	 cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline -2
L73:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r i 20 c
	.dbend
	.dbfunc e PutCharinBuffer _PutCharinBuffer fV
;         inchar -> R10
;        address -> R18
;            row -> R16
	.even
_PutCharinBuffer::
	st -y,R10
	ldd R10,y+1
	.dbline -1
	.dbline 541
; }
; 
; void PutCharinBuffer(unsigned char row,unsigned char address,unsigned char inchar)
; {
	.dbline 542
;     if(row==0)  line1[address] = inchar;
	tst R16
	brne L79
X21:
	.dbline 542
	ldi R24,<_line1
	ldi R25,>_line1
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
	xjmp L80
L79:
	.dbline 543
; 	else if(row==1)  line2[address] = inchar;
	cpi R16,1
	brne L81
X22:
	.dbline 543
	ldi R24,<_line2
	ldi R25,>_line2
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
	xjmp L82
L81:
	.dbline 544
; 	else if(row==2)  line3[address] = inchar;
	cpi R16,2
	brne L83
X23:
	.dbline 544
	ldi R24,<_line3
	ldi R25,>_line3
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
	xjmp L84
L83:
	.dbline 545
; 	else if(row==3)  line4[address] = inchar;
	cpi R16,3
	brne L85
X24:
	.dbline 545
	ldi R24,<_line4
	ldi R25,>_line4
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R10
L85:
L84:
L82:
L80:
	.dbline -2
L78:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbsym r address 18 c
	.dbsym r row 16 c
	.dbend
	.dbfunc e LCD_Dsymbol _LCD_Dsymbol fV
;          state -> R20
	.even
_LCD_Dsymbol::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 549
; }
; 
; void LCD_Dsymbol(unsigned char state)
; {
	.dbline 550
;     if(state==ON) LCD_Write(0x70,0x08);
	cpi R20,1
	brne L88
X25:
	.dbline 550
	ldi R18,8
	ldi R16,112
	xcall _LCD_Write
	xjmp L89
L88:
	.dbline 551
; 	else if(state==OFF) LCD_Write(0x70,0);
	tst R20
	brne L90
X26:
	.dbline 551
	clr R18
	ldi R16,112
	xcall _LCD_Write
L90:
L89:
	.dbline -2
L87:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Rsymbol _LCD_Rsymbol fV
;          state -> R20
	.even
_LCD_Rsymbol::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 555
; }
; 
; void LCD_Rsymbol(unsigned char state)
; {
	.dbline 556
;     if(state==ON) LCD_Write(0x75,0x02);
	cpi R20,1
	brne L93
X27:
	.dbline 556
	ldi R18,2
	ldi R16,117
	xcall _LCD_Write
	xjmp L94
L93:
	.dbline 557
; 	else if(state==OFF) LCD_Write(0x75,0);
	tst R20
	brne L95
X28:
	.dbline 557
	clr R18
	ldi R16,117
	xcall _LCD_Write
L95:
L94:
	.dbline -2
L92:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Vsymbol _LCD_Vsymbol fV
;          state -> R20
	.even
_LCD_Vsymbol::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 561
; }
; 
; void LCD_Vsymbol(unsigned char state)
; {
	.dbline 562
;     if(state==ON) LCD_Write(0x78,0x08);
	cpi R20,1
	brne L98
X29:
	.dbline 562
	ldi R18,8
	ldi R16,120
	xcall _LCD_Write
	xjmp L99
L98:
	.dbline 563
; 	else if(state==OFF) LCD_Write(0x78,0);
	tst R20
	brne L100
X30:
	.dbline 563
	clr R18
	ldi R16,120
	xcall _LCD_Write
L100:
L99:
	.dbline -2
L97:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Phone _LCD_Phone fV
;          state -> R20
	.even
_LCD_Phone::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 567
; }
; 
; void LCD_Phone(unsigned char state)
; {
	.dbline 568
;     if(state==LCD_PHONE_ON) {
	cpi R20,1
	brne L103
X31:
	.dbline 568
	.dbline 569
; 	    lcdphoneantennasymbols |= LCD_PHONE_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	ori R24,2
	sts _lcdphoneantennasymbols,R24
	.dbline 570
; 		LCD_Write(0x73,lcdphoneantennasymbols);
	mov R18,R24
	ldi R16,115
	xcall _LCD_Write
	.dbline 571
; 		LCD_Write(0x74,0);
	clr R18
	ldi R16,116
	xcall _LCD_Write
	.dbline 572
; 	    }
	xjmp L104
L103:
	.dbline 573
; 	else if(state==LCD_SLASHPHONE) {
	cpi R20,2
	brne L105
X32:
	.dbline 573
	.dbline 574
; 	    lcdphoneantennasymbols |= LCD_PHONE_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	ori R24,2
	sts _lcdphoneantennasymbols,R24
	.dbline 575
; 		LCD_Write(0x73,lcdphoneantennasymbols);
	mov R18,R24
	ldi R16,115
	xcall _LCD_Write
	.dbline 576
; 		LCD_Write(0x74,0x08);
	ldi R18,8
	ldi R16,116
	xcall _LCD_Write
	.dbline 577
; 	    }
	xjmp L106
L105:
	.dbline 578
; 	else if(state==LCD_PHONE_OFF) {
	cpi R20,3
	brne L107
X33:
	.dbline 578
	.dbline 579
; 	    lcdphoneantennasymbols &= ~LCD_PHONE_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,253
	sts _lcdphoneantennasymbols,R24
	.dbline 580
; 		LCD_Write(0x73,lcdphoneantennasymbols);
	mov R18,R24
	ldi R16,115
	xcall _LCD_Write
	.dbline 581
; 		LCD_Write(0x74,0);
	clr R18
	ldi R16,116
	xcall _LCD_Write
	.dbline 582
; 	    }
L107:
L106:
L104:
	.dbline -2
L102:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Envelope _LCD_Envelope fV
;          state -> R20
	.even
_LCD_Envelope::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 586
; }
; 
; void LCD_Envelope(unsigned char state)
; {
	.dbline 587
;     if(state==ON) LCD_Write(0x76,0x02);
	cpi R20,1
	brne L110
X34:
	.dbline 587
	ldi R18,2
	ldi R16,118
	xcall _LCD_Write
	xjmp L111
L110:
	.dbline 588
; 	else if(state==OFF) LCD_Write(0x76,0);
	tst R20
	brne L112
X35:
	.dbline 588
	clr R18
	ldi R16,118
	xcall _LCD_Write
L112:
L111:
	.dbline -2
L109:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r state 20 c
	.dbend
	.dbfunc e LCD_Battery _LCD_Battery fV
;          level -> R20
	.even
_LCD_Battery::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 592
; }
; 
; void LCD_Battery(unsigned char level)
; {
	.dbline 593
;  	 if(level==LCD_BATTERY_EMPTY)  {
	cpi R20,2
	brne L115
X36:
	.dbline 593
	.dbline 594
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 595
; 	     LCD_Write(0x7a,0);
	clr R18
	ldi R16,122
	xcall _LCD_Write
	.dbline 596
; 	     LCD_Write(0x7b,0);
	clr R18
	ldi R16,123
	xcall _LCD_Write
	.dbline 597
; 		 }
L115:
	.dbline 598
;  	 if(level==LCD_BATTERY_QUARTER)  {
	cpi R20,3
	brne L117
X37:
	.dbline 598
	.dbline 599
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 600
; 	     LCD_Write(0x7a,0);
	clr R18
	ldi R16,122
	xcall _LCD_Write
	.dbline 601
; 	     LCD_Write(0x7b,0x08);
	ldi R18,8
	ldi R16,123
	xcall _LCD_Write
	.dbline 602
; 		 }
L117:
	.dbline 603
;  	 if(level==LCD_BATTERY_HALF)  {
	cpi R20,4
	brne L119
X38:
	.dbline 603
	.dbline 604
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 605
; 	     LCD_Write(0x7a,0x02);
	ldi R18,2
	ldi R16,122
	xcall _LCD_Write
	.dbline 606
; 	     LCD_Write(0x7b,0x08);
	ldi R18,8
	ldi R16,123
	xcall _LCD_Write
	.dbline 607
; 		 }
L119:
	.dbline 608
;  	 if(level==LCD_BATTERY_THREEQUARTER)  {
	cpi R20,5
	brne L121
X39:
	.dbline 608
	.dbline 609
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 610
; 	     LCD_Write(0x7a,0x02);
	ldi R18,2
	ldi R16,122
	xcall _LCD_Write
	.dbline 611
; 	     LCD_Write(0x7b,0x0b);
	ldi R18,11
	ldi R16,123
	xcall _LCD_Write
	.dbline 612
; 		 }
L121:
	.dbline 613
;  	 if(level==LCD_BATTERY_FULL)  {
	cpi R20,6
	brne L123
X40:
	.dbline 613
	.dbline 614
; 	     LCD_Write(0x79,0x02);
	ldi R18,2
	ldi R16,121
	xcall _LCD_Write
	.dbline 615
; 	     LCD_Write(0x7a,0x0b);
	ldi R18,11
	ldi R16,122
	xcall _LCD_Write
	.dbline 616
; 	     LCD_Write(0x7b,0x0b);
	ldi R18,11
	ldi R16,123
	xcall _LCD_Write
	.dbline 617
; 		 }
L123:
	.dbline 618
;  	 if(level==LCD_BATTERY_OFF)  {
	cpi R20,1
	brne L125
X41:
	.dbline 618
	.dbline 619
; 	     LCD_Write(0x79,0);
	clr R18
	ldi R16,121
	xcall _LCD_Write
	.dbline 620
; 	     LCD_Write(0x7a,0);
	clr R18
	ldi R16,122
	xcall _LCD_Write
	.dbline 621
; 	     LCD_Write(0x7b,0);
	clr R18
	ldi R16,123
	xcall _LCD_Write
	.dbline 622
; 		 }
L125:
	.dbline -2
L114:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r level 20 c
	.dbend
	.dbfunc e LCD_Antenna _LCD_Antenna fV
;          level -> R20
	.even
_LCD_Antenna::
	st -y,R20
	mov R20,R16
	.dbline -1
	.dbline 626
; }
; 
; void LCD_Antenna(unsigned char level)
; {
	.dbline 627
;  	 if(level==LCD_ANTENNA_EMPTY)  {
	cpi R20,2
	brne L128
X42:
	.dbline 627
	.dbline 628
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 629
; 	     LCD_Write(0x71,0x08);
	ldi R18,8
	ldi R16,113
	xcall _LCD_Write
	.dbline 630
; 	     LCD_Write(0x72,0);
	clr R18
	ldi R16,114
	xcall _LCD_Write
	.dbline 631
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 632
; 		 }
L128:
	.dbline 633
;   	 if(level==LCD_ANTENNA_QUARTER)  {
	cpi R20,3
	brne L130
X43:
	.dbline 633
	.dbline 634
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 635
; 	     LCD_Write(0x71,0x0b);
	ldi R18,11
	ldi R16,113
	xcall _LCD_Write
	.dbline 636
; 	     LCD_Write(0x72,0);
	clr R18
	ldi R16,114
	xcall _LCD_Write
	.dbline 637
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 638
; 		 }
L130:
	.dbline 639
;  	 if(level==LCD_ANTENNA_HALF)  {
	cpi R20,4
	brne L132
X44:
	.dbline 639
	.dbline 640
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 641
; 	     LCD_Write(0x71,0x0b);
	ldi R18,11
	ldi R16,113
	xcall _LCD_Write
	.dbline 642
; 	     LCD_Write(0x72,0x08);
	ldi R18,8
	ldi R16,114
	xcall _LCD_Write
	.dbline 643
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 644
; 		 }
L132:
	.dbline 645
;  	 if(level==LCD_ANTENNA_THREEQUARTER)  {
	cpi R20,5
	brne L134
X45:
	.dbline 645
	.dbline 646
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 647
; 	     LCD_Write(0x71,0x0b);
	ldi R18,11
	ldi R16,113
	xcall _LCD_Write
	.dbline 648
; 	     LCD_Write(0x72,0x0b);
	ldi R18,11
	ldi R16,114
	xcall _LCD_Write
	.dbline 649
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 650
; 		 }
L134:
	.dbline 651
;  	 if(level==LCD_ANTENNA_FULL)  {
	cpi R20,6
	brne L136
X46:
	.dbline 651
	.dbline 652
; 	     lcdphoneantennasymbols |= LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	ori R24,8
	sts _lcdphoneantennasymbols,R24
	.dbline 653
; 	     LCD_Write(0x71,0x0b);
	ldi R18,11
	ldi R16,113
	xcall _LCD_Write
	.dbline 654
; 	     LCD_Write(0x72,0x0b);
	ldi R18,11
	ldi R16,114
	xcall _LCD_Write
	.dbline 655
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 656
; 		 }
L136:
	.dbline 657
;  	 if(level==LCD_ANTENNA_OFF)  {
	cpi R20,1
	brne L138
X47:
	.dbline 657
	.dbline 658
; 	     lcdphoneantennasymbols &= ~LCD_BIGANTENNA_SYMBOL;
	lds R24,_lcdphoneantennasymbols
	andi R24,247
	sts _lcdphoneantennasymbols,R24
	.dbline 659
; 	     LCD_Write(0x71,0);
	clr R18
	ldi R16,113
	xcall _LCD_Write
	.dbline 660
; 	     LCD_Write(0x72,0);
	clr R18
	ldi R16,114
	xcall _LCD_Write
	.dbline 661
; 	     LCD_Write(0x73,lcdphoneantennasymbols);
	lds R18,_lcdphoneantennasymbols
	ldi R16,115
	xcall _LCD_Write
	.dbline 662
; 		 }
L138:
	.dbline -2
L127:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r level 20 c
	.dbend
	.dbfunc e GetRowfromLine _GetRowfromLine fc
;           line -> R16
	.even
_GetRowfromLine::
	.dbline -1
	.dbline 666
; }
; 
; unsigned char GetRowfromLine(unsigned char line)
; {
	.dbline 667
;  	 if(line==LINE1) return 0;
	cpi R16,48
	brne L141
X48:
	.dbline 667
	clr R16
	xjmp L140
L141:
	.dbline 668
; 	 if(line==LINE2) return 1;
	cpi R16,64
	brne L143
X49:
	.dbline 668
	ldi R16,1
	xjmp L140
L143:
	.dbline 669
; 	 if(line==LINE3) return 2;
	cpi R16,80
	brne L145
X50:
	.dbline 669
	ldi R16,2
	xjmp L140
L145:
	.dbline 670
; 	 if(line==LINE4) return 3;
	cpi R16,96
	brne L147
X51:
	.dbline 670
	ldi R16,3
	xjmp L140
L147:
	.dbline 671
; 	 return 0;
	clr R16
	.dbline -2
L140:
	.dbline 0 ; func end
	ret
	.dbsym r line 16 c
	.dbend
	.dbfunc e SendCharToDisplay _SendCharToDisplay fV
;         inchar -> R10
	.even
_SendCharToDisplay::
	st -y,R10
	mov R10,R16
	sbiw R28,1
	.dbline -1
	.dbline 675
; }
; 
; void SendCharToDisplay(unsigned char inchar)
; {
	.dbline 676
; 	if(cursorposition>11) {
	ldi R24,11
	lds R2,_cursorposition
	cp R24,R2
	brsh L150
X52:
	.dbline 676
	.dbline 677
; 		if(lineptr==LINE4) ShiftUpLine();
	lds R24,_lineptr
	cpi R24,96
	brne L152
X53:
	.dbline 677
	xcall _ShiftUpLine
	xjmp L153
L152:
	.dbline 678
; 		else {
	.dbline 679
; 			lineptr += 0x10;
	lds R24,_lineptr
	subi R24,240    ; addi 16
	sts _lineptr,R24
	.dbline 680
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 681
; 			}
L153:
	.dbline 682
; 		}				
L150:
	.dbline 683
; 	LCDDisplayChar(lineptr+cursorposition,inchar);
	mov R18,R10
	lds R2,_cursorposition
	lds R16,_lineptr
	add R16,R2
	xcall _LCDDisplayChar
	.dbline 684
; 	PutCharinBuffer(GetRowfromLine(lineptr),inchar,cursorposition);
	lds R16,_lineptr
	xcall _GetRowfromLine
	lds R2,_cursorposition
	std y+0,R2
	mov R18,R10
	xcall _PutCharinBuffer
	.dbline 685
; 	cursorposition++;
	lds R24,_cursorposition
	subi R24,255    ; addi 1
	sts _cursorposition,R24
	.dbline -2
L149:
	.dbline 0 ; func end
	adiw R28,1
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e IncrementLinePtr _IncrementLinePtr fV
	.even
_IncrementLinePtr::
	.dbline -1
	.dbline 689
; }
; 
; void IncrementLinePtr()
; {
	.dbline 690
;     if(lineptr==LINE1)  lineptr = LINE2;
	lds R24,_lineptr
	cpi R24,48
	brne L155
X54:
	.dbline 690
	ldi R24,64
	sts _lineptr,R24
	xjmp L156
L155:
	.dbline 691
; 	else if(lineptr==LINE2) lineptr = LINE3;
	lds R24,_lineptr
	cpi R24,64
	brne L157
X55:
	.dbline 691
	ldi R24,80
	sts _lineptr,R24
	xjmp L158
L157:
	.dbline 692
; 	else if(lineptr==LINE3) lineptr = LINE4;
	lds R24,_lineptr
	cpi R24,80
	brne L159
X56:
	.dbline 692
	ldi R24,96
	sts _lineptr,R24
L159:
L158:
L156:
	.dbline -2
L154:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ParseEscSubCommand _ParseEscSubCommand fV
;         inchar -> R20
	.even
_ParseEscSubCommand::
	xcall push_xgsetF000
	mov R20,R16
	.dbline -1
	.dbline 696
; }
; 
; void ParseEscSubCommand(unsigned char inchar)
; {
	.dbline 697
;  	 switch (symbolmode) {
	lds R22,_symbolmode
	clr R23
	cpi R22,8
	ldi R30,0
	cpc R23,R30
	breq L165
X57:
	cpi R22,10
	ldi R30,0
	cpc R23,R30
	breq L172
X58:
	cpi R22,11
	ldi R30,0
	cpc R23,R30
	breq L179
X59:
	xjmp L162
L165:
	.dbline 699
; 		case TWI_ADDRESS_STATE:
; 		    if(inchar==LCD_PHONE_ON) LCD_Phone(LCD_PHONE_ON);
	cpi R20,1
	brne L166
X60:
	.dbline 699
	ldi R16,1
	xcall _LCD_Phone
	xjmp L163
L166:
	.dbline 700
; 			else if(inchar==LCD_SLASHPHONE) LCD_Phone(LCD_SLASHPHONE);
	cpi R20,2
	brne L168
X61:
	.dbline 700
	ldi R16,2
	xcall _LCD_Phone
	xjmp L163
L168:
	.dbline 701
; 			else if(inchar==LCD_PHONE_ON) LCD_Phone(LCD_PHONE_OFF);
	cpi R20,1
	brne L163
X62:
	.dbline 701
	ldi R16,3
	xcall _LCD_Phone
	.dbline 702
; 			break;
	xjmp L163
L172:
	.dbline 704
; 		case LED_BLINK_STATE:
; 		    if(inchar==LCD_PHONE_ON) LCD_Phone(LCD_PHONE_ON);
	cpi R20,1
	brne L173
X63:
	.dbline 704
	ldi R16,1
	xcall _LCD_Phone
	xjmp L163
L173:
	.dbline 705
; 			else if(inchar==LCD_SLASHPHONE) LCD_Phone(LCD_SLASHPHONE);
	cpi R20,2
	brne L175
X64:
	.dbline 705
	ldi R16,2
	xcall _LCD_Phone
	xjmp L163
L175:
	.dbline 706
; 			else if(inchar==LCD_PHONE_ON) LCD_Phone(LCD_PHONE_OFF);
	cpi R20,1
	brne L163
X65:
	.dbline 706
	ldi R16,3
	xcall _LCD_Phone
	.dbline 707
; 			break;
	xjmp L163
L179:
	.dbline 709
; 		case VOLTAGE_STATE:
; 		    if(inchar=='o') LCD_Vsymbol(ON);
	cpi R20,111
	brne L180
X66:
	.dbline 709
	ldi R16,1
	xcall _LCD_Vsymbol
	xjmp L163
L180:
	.dbline 710
; 			else if(inchar=='f') LCD_Vsymbol(OFF);
	cpi R20,102
	brne L163
X67:
	.dbline 710
	clr R16
	xcall _LCD_Vsymbol
	.dbline 711
; 			break;
L162:
L163:
	.dbline 713
; 		}
;  	 lcdstate = NO_ACTIVE_STATE;
	clr R2
	sts _lcdstate,R2
	.dbline -2
L161:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inchar 20 c
	.dbend
	.dbfunc e ParseSymbolCommand _ParseSymbolCommand fV
;         inchar -> R20
	.even
_ParseSymbolCommand::
	xcall push_xgsetF000
	mov R20,R16
	.dbline -1
	.dbline 717
; }
; 
; void ParseSymbolCommand(unsigned char inchar)
; {
	.dbline 718
;  	 switch (symbolmode) {
	lds R22,_symbolmode
	clr R23
	cpi R22,1
	ldi R30,0
	cpc R23,R30
	breq L188
X68:
	cpi R22,2
	ldi R30,0
	cpc R23,R30
	breq L189
X69:
	cpi R22,3
	ldi R30,0
	cpc R23,R30
	breq L190
X70:
	cpi R22,4
	ldi R30,0
	cpc R23,R30
	breq L195
X71:
	cpi R22,5
	ldi R30,0
	cpc R23,R30
	breq L200
X72:
	cpi R22,6
	ldi R30,0
	cpc R23,R30
	breq L205
X73:
	cpi R22,7
	ldi R30,0
	cpc R23,R30
	brne X83
	xjmp L210
X83:
X74:
	xjmp L185
L188:
	.dbline 720
; 		case ANTENNA_STATE:
; 		    LCD_Antenna(inchar);
	mov R16,R20
	xcall _LCD_Antenna
	.dbline 721
; 			break;
	xjmp L186
L189:
	.dbline 723
; 		case BATTERY_STATE:
; 		    LCD_Battery(inchar);
	mov R16,R20
	xcall _LCD_Battery
	.dbline 724
; 			break;
	xjmp L186
L190:
	.dbline 726
; 		case VSYM_STATE:
; 		    if(inchar=='o') LCD_Vsymbol(ON);
	cpi R20,111
	brne L191
X75:
	.dbline 726
	ldi R16,1
	xcall _LCD_Vsymbol
	xjmp L186
L191:
	.dbline 727
; 			else if(inchar=='f') LCD_Vsymbol(OFF);
	cpi R20,102
	brne L186
X76:
	.dbline 727
	clr R16
	xcall _LCD_Vsymbol
	.dbline 728
; 			break;
	xjmp L186
L195:
	.dbline 730
; 		case DSYM_STATE:
; 		    if(inchar=='o') LCD_Dsymbol(ON);
	cpi R20,111
	brne L196
X77:
	.dbline 730
	ldi R16,1
	xcall _LCD_Dsymbol
	xjmp L186
L196:
	.dbline 731
; 			else if(inchar=='f') LCD_Dsymbol(OFF);
	cpi R20,102
	brne L186
X78:
	.dbline 731
	clr R16
	xcall _LCD_Dsymbol
	.dbline 732
; 			break;
	xjmp L186
L200:
	.dbline 734
; 		case RSYM_STATE:
; 		    if(inchar=='o') LCD_Rsymbol(ON);
	cpi R20,111
	brne L201
X79:
	.dbline 734
	ldi R16,1
	xcall _LCD_Rsymbol
	xjmp L186
L201:
	.dbline 735
; 			else if(inchar=='f') LCD_Rsymbol(OFF);
	cpi R20,102
	brne L186
X80:
	.dbline 735
	clr R16
	xcall _LCD_Rsymbol
	.dbline 736
; 			break;
	xjmp L186
L205:
	.dbline 738
; 		case ENVELOPE_STATE:
; 		    if(inchar=='o') LCD_Envelope(ON);
	cpi R20,111
	brne L206
X81:
	.dbline 738
	ldi R16,1
	xcall _LCD_Envelope
	xjmp L186
L206:
	.dbline 739
; 			else if(inchar=='f') LCD_Envelope(OFF);
	cpi R20,102
	brne L186
X82:
	.dbline 739
	clr R16
	xcall _LCD_Envelope
	.dbline 740
; 			break;
	xjmp L186
L210:
	.dbline 742
; 		case PHONE_STATE:
; 		    LCD_Phone(inchar);
	mov R16,R20
	xcall _LCD_Phone
	.dbline 743
; 			break;
L185:
L186:
	.dbline 745
; 	     }
;  	 lcdstate = NO_ACTIVE_STATE;
	clr R2
	sts _lcdstate,R2
	.dbline 746
; 	 symbolmode = NO_ACTIVE_STATE;
	sts _symbolmode,R2
	.dbline -2
L184:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inchar 20 c
	.dbend
	.dbfunc e ParseEscCommand _ParseEscCommand fV
;         inchar -> R10
	.even
_ParseEscCommand::
	xcall push_xgset300C
	mov R10,R16
	.dbline -1
	.dbline 750
; }
; 
; void ParseEscCommand(unsigned char inchar)
; {
	.dbline 751
;     switch (inchar) {
	mov R20,R10
	clr R21
	cpi R20,99
	ldi R30,0
	cpc R21,R30
	brne X97
	xjmp L215
X97:
X84:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	brne X98
	xjmp L221
X98:
X85:
	ldi R24,102
	ldi R25,0
	cp R24,R20
	cpc R25,R21
	brlt L227
X86:
L226:
	cpi R20,49
	ldi R30,0
	cpc R21,R30
	brne X99
	xjmp L216
X99:
X87:
	cpi R20,50
	ldi R30,0
	cpc R21,R30
	brne X100
	xjmp L217
X100:
X88:
	cpi R20,51
	ldi R30,0
	cpc R21,R30
	brne X101
	xjmp L218
X101:
X89:
	cpi R20,52
	ldi R30,0
	cpc R21,R30
	brne X102
	xjmp L219
X102:
X90:
	xjmp L212
L227:
	cpi R20,108
	ldi R30,0
	cpc R21,R30
	brne X103
	xjmp L224
X103:
X91:
	cpi R20,111
	ldi R30,0
	cpc R21,R30
	brne X104
	xjmp L220
X104:
X92:
	cpi R20,108
	ldi R30,0
	cpc R21,R30
	brge X105
	xjmp L212
X105:
X93:
L228:
	cpi R20,115
	ldi R30,0
	cpc R21,R30
	brne X106
	xjmp L222
X106:
X94:
	cpi R20,116
	ldi R30,0
	cpc R21,R30
	brne X107
	xjmp L225
X107:
X95:
	cpi R20,118
	ldi R30,0
	cpc R21,R30
	brne X108
	xjmp L223
X108:
X96:
	xjmp L212
L215:
	.dbline 753
; 	    case 'c':
; 		    Clear_LCD();
	xcall _Clear_LCD
	.dbline 754
; 			lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 755
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 756
; 			escmode = OFF;
	sts _escmode,R2
	.dbline 757
; 			break;
	xjmp L213
L216:
	.dbline 759
; 		case '1':
; 		    lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 760
; 		    cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 761
; 			escmode = OFF;
	sts _escmode,R2
	.dbline 762
; 			break;
	xjmp L213
L217:
	.dbline 764
; 		case '2':
; 		    lineptr = LINE2;
	ldi R24,64
	sts _lineptr,R24
	.dbline 765
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 766
; 			escmode = OFF;
	sts _escmode,R2
	.dbline 767
; 			break;
	xjmp L213
L218:
	.dbline 769
; 		case '3':
; 		    lineptr = LINE3;
	ldi R24,80
	sts _lineptr,R24
	.dbline 770
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 771
; 			escmode = OFF;
	sts _escmode,R2
	.dbline 772
; 			break;
	xjmp L213
L219:
	.dbline 774
; 		case '4':
; 		    lineptr = LINE4;
	ldi R24,96
	sts _lineptr,R24
	.dbline 775
; 			cursorposition = 0;
	clr R2
	sts _cursorposition,R2
	.dbline 776
; 			escmode = OFF;
	sts _escmode,R2
	.dbline 777
; 			break;
	xjmp L213
L220:
	.dbline 779
; 		case 'o':
; 		    LCD_LED_Power(ON);
	ldi R16,1
	xcall _LCD_LED_Power
	.dbline 780
; 			escmode = OFF;
	clr R2
	sts _escmode,R2
	.dbline 781
; 			break;
	xjmp L213
L221:
	.dbline 783
; 		case 'f':
; 		    LCD_LED_Power(OFF);
	clr R16
	xcall _LCD_LED_Power
	.dbline 784
; 			escmode = OFF;
	clr R2
	sts _escmode,R2
	.dbline 785
; 			break;
	xjmp L213
L222:
	.dbline 787
; 		case 's':
; 		    lcdstate = LCD_SYMBOL_STATE;
	ldi R24,9
	sts _lcdstate,R24
	.dbline 788
; 			break;
	xjmp L213
L223:
	.dbline 790
; 		case 'v':
; 		    lcdstate = VOLTAGE_STATE;
	ldi R24,11
	sts _lcdstate,R24
	.dbline 791
; 			break;
	xjmp L213
L224:
	.dbline 793
; 		case 'l':
; 		    lcdstate = LED_BLINK_STATE;
	ldi R24,10
	sts _lcdstate,R24
	.dbline 794
; 			break;
	xjmp L213
L225:
	.dbline 796
; 		case 't':
; 		    lcdstate = TWI_ADDRESS_STATE;
	ldi R24,8
	sts _lcdstate,R24
	.dbline 797
; 			break;
	xjmp L213
L212:
	.dbline 799
; 		default:
; 		    escmode = OFF;
	clr R2
	sts _escmode,R2
	.dbline 800
; 			break;
L213:
	.dbline 802
; 		}
; 	escmode = OFF;
	clr R2
	sts _escmode,R2
	.dbline -2
L211:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e ParseChar _ParseChar fV
;         inchar -> R10
	.even
_ParseChar::
	xcall push_xgset300C
	mov R10,R16
	.dbline -1
	.dbline 806
; }
; 
; void ParseChar(unsigned char inchar)
; {
	.dbline 807
; 	if(escmode==ON) {
	lds R24,_escmode
	cpi R24,1
	brne L230
X109:
	.dbline 807
	.dbline 808
; 		ParseEscCommand(inchar);
	mov R16,R10
	xcall _ParseEscCommand
	.dbline 809
; 		}
	xjmp L231
L230:
	.dbline 810
; 	else {
	.dbline 811
; 	    if(symbolmode)  ParseSymbolCommand(inchar);
	lds R2,_symbolmode
	tst R2
	breq L232
X110:
	.dbline 811
	mov R16,R10
	xcall _ParseSymbolCommand
	xjmp L233
L232:
	.dbline 812
; 	    else if(lcdstate==LCD_SYMBOL_STATE) symbolmode = inchar;
	lds R24,_lcdstate
	cpi R24,9
	brne L234
X111:
	.dbline 812
	sts _symbolmode,R10
	xjmp L235
L234:
	.dbline 813
; 		else if(lcdstate) ParseEscSubCommand(inchar);
	lds R2,_lcdstate
	tst R2
	breq L236
X112:
	.dbline 813
	mov R16,R10
	xcall _ParseEscSubCommand
	xjmp L237
L236:
	.dbline 814
; 		else {
	.dbline 815
; 	      switch (inchar) {
	mov R20,R10
	clr R21
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	brne X126
	xjmp L246
X126:
X113:
	cpi R20,2
	ldi R30,0
	cpc R21,R30
	brne X127
	xjmp L247
X127:
X114:
	cpi R20,3
	ldi R30,0
	cpc R21,R30
	brne X128
	xjmp L248
X128:
X115:
	cpi R20,4
	ldi R30,0
	cpc R21,R30
	brne X129
	xjmp L249
X129:
X116:
	cpi R20,5
	ldi R30,0
	cpc R21,R30
	brne X130
	xjmp L250
X130:
X117:
	cpi R20,6
	ldi R30,0
	cpc R21,R30
	brne X131
	xjmp L251
X131:
X118:
	cpi R20,7
	ldi R30,0
	cpc R21,R30
	brne X132
	xjmp L252
X132:
X119:
	cpi R20,8
	ldi R30,0
	cpc R21,R30
	brne X133
	xjmp L253
X133:
X120:
	cpi R20,10
	ldi R30,0
	cpc R21,R30
	breq L243
X121:
	cpi R20,13
	ldi R30,0
	cpc R21,R30
	breq L242
X122:
	cpi R20,1
	ldi R30,0
	cpc R21,R30
	brge X134
	xjmp L238
X134:
X123:
L254:
	cpi R20,27
	ldi R30,0
	cpc R21,R30
	breq L241
X124:
	xjmp L238
L241:
	.dbline 817
; 		    case ESC:
; 				escmode = ON;  
	ldi R24,1
	sts _escmode,R24
	.dbline 818
; 				break;
	xjmp L239
L242:
	.dbline 820
; 		    case CR:
; 				cursorposition = 0; 
	clr R2
	sts _cursorposition,R2
	.dbline 821
; 				break;
	xjmp L239
L243:
	.dbline 823
; 		    case LF:
; 				if(lineptr==LINE4) ShiftUpLine();
	lds R24,_lineptr
	cpi R24,96
	brne L244
X125:
	.dbline 823
	xcall _ShiftUpLine
	xjmp L239
L244:
	.dbline 824
;  				else IncrementLinePtr();
	xcall _IncrementLinePtr
	.dbline 825
; 				break;
	xjmp L239
L246:
	.dbline 827
; 		    case 0x01:
; 				LCD_Vsymbol(ON); 
	ldi R16,1
	xcall _LCD_Vsymbol
	.dbline 828
; 				break;
	xjmp L239
L247:
	.dbline 830
; 		    case 0x02:
; 				LCD_Vsymbol(OFF);  
	clr R16
	xcall _LCD_Vsymbol
	.dbline 831
; 				break;
	xjmp L239
L248:
	.dbline 833
; 		    case 0x03:
; 				LCD_Dsymbol(ON); 
	ldi R16,1
	xcall _LCD_Dsymbol
	.dbline 834
; 				break;
	xjmp L239
L249:
	.dbline 836
; 		    case 0x04:
; 				LCD_Dsymbol(OFF);  
	clr R16
	xcall _LCD_Dsymbol
	.dbline 837
; 				break;
	xjmp L239
L250:
	.dbline 839
; 		    case 0x05:
; 				LCD_Rsymbol(ON); 
	ldi R16,1
	xcall _LCD_Rsymbol
	.dbline 840
; 				break;
	xjmp L239
L251:
	.dbline 842
; 		    case 0x06:
; 				LCD_Rsymbol(OFF);  
	clr R16
	xcall _LCD_Rsymbol
	.dbline 843
; 				break;
	xjmp L239
L252:
	.dbline 845
; 		    case 0x07:
; 				LCD_Envelope(ON); 
	ldi R16,1
	xcall _LCD_Envelope
	.dbline 846
; 				break;
	xjmp L239
L253:
	.dbline 848
; 		    case 0x08:
; 				LCD_Envelope(OFF);  
	clr R16
	xcall _LCD_Envelope
	.dbline 849
; 				break;
	xjmp L239
L238:
	.dbline 851
; 			default:
; 			    SendCharToDisplay(inchar);
	mov R16,R10
	xcall _SendCharToDisplay
	.dbline 852
; 				break;
L239:
	.dbline 854
; 			}
; 		  }
L237:
L235:
L233:
	.dbline 855
; 		}
L231:
	.dbline -2
L229:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e ParseStrg _ParseStrg fV
;              i -> R10
;         instrg -> R12,R13
	.even
_ParseStrg::
	xcall push_xgset003C
	movw R12,R16
	.dbline -1
	.dbline 859
; }
; 
; void ParseStrg(unsigned char *instrg)
; {
	.dbline 862
;  	 unsigned char i;
; 	 
; 	 for(i=0; i<strlen(instrg); i++)  ParseChar(instrg[i]);
	clr R10
	xjmp L259
L256:
	.dbline 862
	mov R30,R10
	clr R31
	add R30,R12
	adc R31,R13
	ldd R16,z+0
	xcall _ParseChar
L257:
	.dbline 862
	inc R10
L259:
	.dbline 862
	movw R16,R12
	xcall _strlen
	mov R2,R10
	clr R3
	cp R2,R16
	cpc R3,R17
	brlo L256
X135:
	.dbline -2
L255:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.dbsym r i 10 c
	.dbsym r instrg 12 pc
	.dbend
	.dbfunc e PutStringinBuffer _PutStringinBuffer fV
;              i -> R10
;           strg -> R12,R13
;         column -> R14
;            row -> R20
	.even
_PutStringinBuffer::
	xcall push_xgset30FC
	mov R14,R18
	mov R20,R16
	sbiw R28,1
	ldd R12,y+9
	ldd R13,y+10
	.dbline -1
	.dbline 866
; }
; 
; void PutStringinBuffer(unsigned char row,unsigned char column,char *strg)
; {	 
	.dbline 869
; 	 unsigned char i;
; 	 
; 	 for(i=0; i<strlen(strg); i++)  PutCharinBuffer(row,column+i,strg[i]);
	clr R10
	xjmp L264
L261:
	.dbline 869
	mov R30,R10
	clr R31
	add R30,R12
	adc R31,R13
	ldd R2,z+0
	std y+0,R2
	mov R18,R14
	add R18,R10
	mov R16,R20
	xcall _PutCharinBuffer
L262:
	.dbline 869
	inc R10
L264:
	.dbline 869
	movw R16,R12
	xcall _strlen
	mov R2,R10
	clr R3
	cp R2,R16
	cpc R3,R17
	brlo L261
X136:
	.dbline -2
L260:
	.dbline 0 ; func end
	adiw R28,1
	xjmp pop_xgset30FC
	.dbsym r i 10 c
	.dbsym r strg 12 pc
	.dbsym r column 14 c
	.dbsym r row 20 c
	.dbend
	.dbfunc e GetLine _GetLine fc
;            row -> R16
	.even
_GetLine::
	.dbline -1
	.dbline 873
; }
; 
; unsigned char GetLine(unsigned char row)
; {
	.dbline 874
;     if(row==0) return LINE1;
	tst R16
	brne L266
X137:
	.dbline 874
	ldi R16,48
	xjmp L265
L266:
	.dbline 875
; 	if(row==1) return LINE2;
	cpi R16,1
	brne L268
X138:
	.dbline 875
	ldi R16,64
	xjmp L265
L268:
	.dbline 876
; 	if(row==2) return LINE3;
	cpi R16,2
	brne L270
X139:
	.dbline 876
	ldi R16,80
	xjmp L265
L270:
	.dbline 877
; 	if(row==3) return LINE4;
	cpi R16,3
	brne L272
X140:
	.dbline 877
	ldi R16,96
	xjmp L265
L272:
	.dbline 878
; 	return LINE1;
	ldi R16,48
	.dbline -2
L265:
	.dbline 0 ; func end
	ret
	.dbsym r row 16 c
	.dbend
	.dbfunc e Display_Voltage_Volume _Display_Voltage_Volume fV
;    analogvalue -> <dead>
;           strg -> y+2
;         column -> R20
;            row -> R10
	.even
_Display_Voltage_Volume::
	st -y,R10
	st -y,R20
	mov R20,R18
	mov R10,R16
	sbiw R28,7
	.dbline -1
	.dbline 882
; }
; 
; void Display_Voltage_Volume(unsigned char row,unsigned char column)
; {
	.dbline 886
;  	 char strg[5];
;  	 int analogvalue;
; 	 
; 	 PutStringinBuffer(row,column,"Volt v=");
	ldi R24,<L275
	ldi R25,>L275
	std y+1,R25
	std y+0,R24
	mov R18,R20
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline 887
; 	 bytetohex(voltagevolume);
	lds R16,_voltagevolume
	xcall _bytetohex
	.dbline 888
; 	 strcpy(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcpy
	.dbline 889
; 	 PutStringinBuffer(row,column+7,hexbyte);
	ldi R24,<_hexbyte
	ldi R25,>_hexbyte
	std y+1,R25
	std y+0,R24
	mov R18,R20
	subi R18,249    ; addi 7
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline -2
L274:
	.dbline 0 ; func end
	adiw R28,7
	ld R20,y+
	ld R10,y+
	ret
	.dbsym l analogvalue 3 I
	.dbsym l strg 2 A[5:5]c
	.dbsym r column 20 c
	.dbsym r row 10 c
	.dbend
	.dbfunc e Display_Voltage_Reference _Display_Voltage_Reference fV
;     newvoltvol -> <dead>
;    analogvalue -> R22,R23
;           strg -> y+2
;         column -> R20
;            row -> R10
	.even
_Display_Voltage_Reference::
	xcall push_xgsetF00C
	mov R20,R18
	mov R10,R16
	sbiw R28,7
	.dbline -1
	.dbline 893
; }
; 
; void Display_Voltage_Reference(unsigned char row,unsigned char column)
; {
	.dbline 897
;  	 char strg[5];
;  	 int analogvalue,newvoltvol;
; 	 
; 	 PutStringinBuffer(row,column,"Analog0=");
	ldi R24,<L277
	ldi R25,>L277
	std y+1,R25
	std y+0,R24
	mov R18,R20
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline 898
;  	 analogvalue = Read_ADC(0, ADCINTERNAL);
	clr R18
	clr R16
	xcall _Read_ADC
	movw R22,R16
	.dbline 900
; 	  
; 	 bytetohex((analogvalue>>8)&0xff);
	mov R16,R17
	clr R17
	sbrc R16,7
	com R17
	andi R17,0
	xcall _bytetohex
	.dbline 901
; 	 strcpy(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcpy
	.dbline 902
; 	 bytetohex((analogvalue&0x00ff));
	mov R16,R22
	andi R17,0
	xcall _bytetohex
	.dbline 903
; 	 strcat(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 904
; 	 PutStringinBuffer(row,column+8,strg);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	mov R18,R20
	subi R18,248    ; addi 8
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline -2
L276:
	.dbline 0 ; func end
	adiw R28,7
	xjmp pop_xgsetF00C
	.dbsym l newvoltvol 3 I
	.dbsym r analogvalue 22 I
	.dbsym l strg 2 A[5:5]c
	.dbsym r column 20 c
	.dbsym r row 10 c
	.dbend
	.dbfunc e Adjust_VoltageVolume _Adjust_VoltageVolume fV
	.even
_Adjust_VoltageVolume::
	.dbline -1
	.dbline 908
; }
; 
; void  Adjust_VoltageVolume()
; {
	.dbline 909
; 	 if((voltagevolume=(1+(574-Read_ADC(0,ADCINTERNAL))/14))>0x0f) 
	clr R18
	clr R16
	xcall _Read_ADC
	movw R2,R16
	ldi R16,574
	ldi R17,2
	sub R16,R2
	sbc R17,R3
	ldi R18,14
	ldi R19,0
	xcall div16s
	movw R24,R16
	adiw R24,1
	mov R2,R24
	sts _voltagevolume,R2
	ldi R24,15
	cp R24,R2
	brsh L279
X141:
	.dbline 911
; //	 if((voltagevolume=(1+(554-Read_ADC(0,ADCINTERNAL))/14))>0x0f) 
; 	     voltagevolume = 0x0c;
	ldi R24,12
	sts _voltagevolume,R24
L279:
	.dbline 912
; 	 LCDwritecommand(LCDVOLREG|voltagevolume); 
	lds R16,_voltagevolume
	ori R16,112
	xcall _LCDwritecommand
	.dbline -2
L278:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisplayTime _DisplayTime fV
;           strg -> y+2
;         column -> R12
;            row -> R10
	.even
_DisplayTime::
	st -y,R10
	st -y,R12
	mov R12,R18
	mov R10,R16
	sbiw R28,11
	.dbline -1
	.dbline 917
; }
; 
; 
; void DisplayTime(unsigned char row,unsigned char column)
; {
	.dbline 921
;  	 char strg[9];
; 	 	
; 	 //PutStringinBuffer(column,"t=");
; 	 bytetoint(hours);
	lds R16,_hours
	xcall _bytetoint
	.dbline 922
; 	 strcpy(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcpy
	.dbline 923
; 	 strcat(strg,":");
	ldi R18,<L282
	ldi R19,>L282
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 924
; 	 bytetoint(minutes);
	lds R16,_minutes
	xcall _bytetoint
	.dbline 925
; 	 strcat(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 926
; 	 strcat(strg,":");
	ldi R18,<L282
	ldi R19,>L282
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 927
; 	 bytetoint(seconds);
	lds R16,_seconds
	xcall _bytetoint
	.dbline 928
; 	 strcat(strg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 929
; 	 PutStringinBuffer(row,column,strg);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	mov R18,R12
	mov R16,R10
	xcall _PutStringinBuffer
	.dbline -2
L281:
	.dbline 0 ; func end
	adiw R28,11
	ld R12,y+
	ld R10,y+
	ret
	.dbsym l strg 2 A[9:9]c
	.dbsym r column 12 c
	.dbsym r row 10 c
	.dbend
	.dbfunc e Display_Display_Parameters _Display_Display_Parameters fV
	.even
_Display_Display_Parameters::
	.dbline -1
	.dbline 933
; }
; 
; void Display_Display_Parameters()
; {
	.dbline 934
; 	if(flip2==ON) {
	lds R24,_flip2
	cpi R24,1
	brne L284
X142:
	.dbline 934
	.dbline 936
; 		//LCD_Symbols(ON);
; 		Display_Voltage_Reference(0,0);
	clr R18
	clr R16
	xcall _Display_Voltage_Reference
	.dbline 937
; 		Display_Voltage_Volume(1,0);
	clr R18
	ldi R16,1
	xcall _Display_Voltage_Volume
	.dbline 938
; 		DisplayTime(3,0);
	clr R18
	ldi R16,3
	xcall _DisplayTime
	.dbline 939
; 		LED_Power(OFF);
	clr R16
	xcall _LED_Power
	.dbline 941
; 		//LCD_LED_Power(ON);
; 		flip2 = YES;
	ldi R24,1
	sts _flip2,R24
	.dbline 943
; 		//line4[11] = '.';
;     	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 944
; 		}
	xjmp L285
L284:
	.dbline 945
; 	else {
	.dbline 948
; 		//line4[11] = ' ';
; 		//LCD_Symbols(OFF);	
;     	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 950
; 		//LCD_LED_Power(OFF);
; 		LED_Power(ON);
	ldi R16,1
	xcall _LED_Power
	.dbline 951
; 		flip2 = NO;
	clr R2
	sts _flip2,R2
	.dbline 952
; 		}
L285:
	.dbline 953
; 	mseccountdown2 = 250;
	ldi R24,250
	ldi R25,0
	sts _mseccountdown2+1,R25
	sts _mseccountdown2,R24
	.dbline -2
L283:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisplayPointPattern _DisplayPointPattern fV
	.even
_DisplayPointPattern::
	.dbline -1
	.dbline 957
; }
; 
; void DisplayPointPattern()
; {
	.dbline 958
; 	Delaymsec(750);
	ldi R16,750
	ldi R17,2
	xcall _Delaymsec
	.dbline 959
; 	line4[7] = '.';
	ldi R24,46
	sts _line4+7,R24
	.dbline 960
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 961
; 	Delaymsec(750);
	ldi R16,750
	ldi R17,2
	xcall _Delaymsec
	.dbline 962
; 	line4[8] = '.';
	ldi R24,46
	sts _line4+8,R24
	.dbline 963
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 964
; 	Delaymsec(750);
	ldi R16,750
	ldi R17,2
	xcall _Delaymsec
	.dbline 965
; 	line4[9] = '.';
	ldi R24,46
	sts _line4+9,R24
	.dbline 966
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 967
; 	Delaymsec(750);
	ldi R16,750
	ldi R17,2
	xcall _Delaymsec
	.dbline 968
; 	line4[10] = '.';
	ldi R24,46
	sts _line4+10,R24
	.dbline 969
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 970
; 	Delaymsec(750);
	ldi R16,750
	ldi R17,2
	xcall _Delaymsec
	.dbline 971
; 	line4[11] = '.';
	ldi R24,46
	sts _line4+11,R24
	.dbline 972
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 973
; 	Delaymsec(750);
	ldi R16,750
	ldi R17,2
	xcall _Delaymsec
	.dbline -2
L286:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Display_Count _Display_Count fV
;        outstrg -> y+2
	.even
_Display_Count::
	sbiw R28,14
	.dbline -1
	.dbline 977
; }
; 
; void Display_Count()
; {
	.dbline 980
;  	char outstrg[12];
; 	
; 	rtccountdown1 = 256;
	ldi R24,256
	ldi R25,1
	sts _rtccountdown1+1,R25
	sts _rtccountdown1,R24
	.dbline 981
; 	bytetohex((count>>8)&0xff);
	lds R16,_count
	lds R17,_count+1
	mov R16,R17
	clr R17
	andi R17,0
	xcall _bytetohex
	.dbline 982
; 	strcpy(outstrg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcpy
	.dbline 983
; 	bytetohex((count&0x00ff));
	lds R16,_count
	andi R17,0
	xcall _bytetohex
	.dbline 984
; 	strcat(outstrg,hexbyte);
	ldi R18,<_hexbyte
	ldi R19,>_hexbyte
	movw R16,R28
	subi R16,254  ; offset = 2
	sbci R17,255
	xcall _strcat
	.dbline 985
; 	PutStringinBuffer(2,0,"count=");
	ldi R24,<L293
	ldi R25,>L293
	std y+1,R25
	std y+0,R24
	clr R18
	ldi R16,2
	xcall _PutStringinBuffer
	.dbline 986
; 	PutStringinBuffer(2,6,outstrg);
	movw R24,R28
	adiw R24,2
	std y+1,R25
	std y+0,R24
	ldi R18,6
	ldi R16,2
	xcall _PutStringinBuffer
	.dbline 987
; 	count++;
	lds R24,_count
	lds R25,_count+1
	adiw R24,1
	sts _count+1,R25
	sts _count,R24
	.dbline -2
L292:
	.dbline 0 ; func end
	adiw R28,14
	ret
	.dbsym l outstrg 2 A[12:12]c
	.dbend
	.dbfunc e SplashScreen _SplashScreen fV
	.even
_SplashScreen::
	.dbline -1
	.dbline 991
; }
; 
; void SplashScreen()
; {
	.dbline 992
; 	LoadSignon();
	xcall _LoadSignon
	.dbline 993
; 	LCD_Symbols(ON);
	ldi R16,1
	xcall _LCD_Symbols
	.dbline 994
; 	DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 995
; 	DisplayPointPattern();
	xcall _DisplayPointPattern
	.dbline 996
; 	Clear_LCD();
	xcall _Clear_LCD
	.dbline 997
; 	Delaymsec(250);
	ldi R16,250
	ldi R17,0
	xcall _Delaymsec
	.dbline -2
L294:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e main _main fV
;        realnum -> y+16
;    analogvalue -> <dead>
;              i -> <dead>
;        outstrg -> y+4
;      voltlevel -> R14
;        outbyte -> R14
;      symbolptr -> R14
; TWI_slaveAddress -> R20
;    symbolindex -> R12,R13
;         level2 -> R22
;          level -> R20
;           flip -> R10
;     messageBuf -> y+0
;        outchar -> R14
;         inchar -> y+20
	.even
_main::
	sbiw R28,21
	.dbline -1
	.dbline 1001
; }
; 
; void main()
; {
	.dbline 1008
;     unsigned char inchar,messageBuf[MESSAGEBUF_SIZE], TWI_slaveAddress;
; 	unsigned char symbolptr,level,level2,outbyte,voltlevel,outchar;
;     char flip,outstrg[12];
; 	int i,symbolindex,analogvalue;
; 	float realnum;
; 
; 	Init_AVR();
	xcall _Init_AVR
	.dbline 1009
;     Init_LCD();
	xcall _Init_LCD
	.dbline 1010
;     Clear_LCD();     
	xcall _Clear_LCD
	.dbline 1013
; //   LCDtest();
;    
;     TWI_slaveAddress = TWI_SLAVEADDRESS;  // Set TWI slave address
	.dbline 1018
; //    USI_TWI_Slave_Initialise(TWI_slaveAddress);  // Initialize the TWI interface
; 
; //   load_eeprom_settings();  //load all start values in eeprom
; 
;     DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 1019
;     rowptr = 4;
	ldi R24,4
	sts _rowptr,R24
	.dbline 1020
;     cursorposition = 12;
	ldi R24,12
	sts _cursorposition,R24
	.dbline 1021
;     lineptr = LINE4;
	ldi R24,96
	sts _lineptr,R24
	.dbline 1022
;     escmode = OFF;
	clr R2
	sts _escmode,R2
	.dbline 1023
;     inchar = 0x31;
	ldi R24,49
	std y+20,R24
	.dbline 1024
; 	flip = NO;
	clr R10
	.dbline 1025
; 	flip2 = ON;
	ldi R24,1
	sts _flip2,R24
	.dbline 1026
; 	symbolindex = 0;
	clr R12
	clr R13
	.dbline 1027
; 	symbolptr = 0x00;
	.dbline 1028
; 	level2 = level = 1;
	ldi R20,1
	ldi R22,1
	.dbline 1029
; 	voltlevel = 0;
	.dbline 1030
; 	count = 0;
	clr R3
	sts _count+1,R3
	sts _count,R2
	.dbline 1031
; 	outchar = 0x30;
	.dbline 1033
; 	
; 	key1state=key2state=key3state=key4state=OFF;
	sts _key4state,R2
	sts _key3state,R2
	sts _key2state,R2
	sts _key1state,R2
	.dbline 1034
; 	key1toggle=key2toggle=key3toggle=key4toggle=0;
	sts _key4toggle,R2
	sts _key3toggle,R2
	sts _key2toggle,R2
	sts _key1toggle,R2
	.dbline 1036
; 
;     LCD_Symbols(OFF);
	clr R16
	xcall _LCD_Symbols
	.dbline 1039
; 	//LCD_Antenna(LCD_ANTENNA_FULL);
; 	//LCD_Battery(LCD_BATTERY_FULL);
; 	outbyte = 0;
	clr R14
	.dbline 1041
; 
; 	Adjust_VoltageVolume();
	xcall _Adjust_VoltageVolume
	.dbline 1042
; 	SplashScreen();
	xcall _SplashScreen
	.dbline 1043
; 	lineptr = LINE1;
	ldi R24,48
	sts _lineptr,R24
	.dbline 1044
; 	cursorposition = 0;	
	clr R2
	sts _cursorposition,R2
	xjmp L297
L296:
	.dbline 1051
; 	
; 	//realnum = 12.34;
; 	//realnum = realnum*34.45;
; 	//realnum = sin(realnum);
; 	
; 	//  Monitor TWI and Uart ports for display data
; 	while(1) { 
	.dbline 1053
; 		
; 		LCD_LED_Power(OFF);
	clr R16
	xcall _LCD_LED_Power
	.dbline 1056
; 		//LED_Power(OFF);
; 				
; 	    if(key1state==ON) {
	lds R24,_key1state
	cpi R24,1
	breq X163
	xjmp L299
X163:
X143:
	.dbline 1056
	.dbline 1057
; 	    if(mseccountdown1==0) {
	lds R2,_mseccountdown1
	lds R3,_mseccountdown1+1
	tst R2
	breq X164
	xjmp L301
X164:
	tst R3
	breq X165
	xjmp L301
X165:
X144:
	.dbline 1057
	.dbline 1058
; 		    if(flip==NO) {
	tst R10
	brne L303
X145:
	.dbline 1058
	.dbline 1059
; 				if(symbolindex==0) {
	tst R12
	brne L305
	tst R13
	brne L305
X146:
	.dbline 1059
	.dbline 1060
; 					LCD_Envelope(ON);
	ldi R16,1
	xcall _LCD_Envelope
	.dbline 1061
; 					LCD_Dsymbol(ON);
	ldi R16,1
	xcall _LCD_Dsymbol
	.dbline 1062
; 					LCD_Rsymbol(ON);
	ldi R16,1
	xcall _LCD_Rsymbol
	.dbline 1063
; 					LCD_Vsymbol(ON);
	ldi R16,1
	xcall _LCD_Vsymbol
	.dbline 1064
; 					LCD_Phone(level2++);
	mov R2,R22
	subi R22,255    ; addi 1
	mov R16,R2
	xcall _LCD_Phone
	.dbline 1065
; 					LCD_Battery(level);
	mov R16,R20
	xcall _LCD_Battery
	.dbline 1066
; 					LCD_Antenna(level++);
	mov R2,R20
	subi R20,255    ; addi 1
	mov R16,R2
	xcall _LCD_Antenna
	.dbline 1067
; 					if(level==7) level = 1;
	cpi R20,7
	brne L307
X147:
	.dbline 1067
	ldi R20,1
L307:
	.dbline 1068
; 					if(level2==4) level2 = 1;
	cpi R22,4
	brne L309
X148:
	.dbline 1068
	ldi R22,1
L309:
	.dbline 1069
; 					}
L305:
	.dbline 1070
; 		        DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 1071
; 				flip = YES;
	clr R10
	inc R10
	.dbline 1072
; 		        }
	xjmp L304
L303:
	.dbline 1073
; 		    else {
	.dbline 1074
; 				LCD_Envelope(OFF);
	clr R16
	xcall _LCD_Envelope
	.dbline 1075
; 				LCD_Dsymbol(OFF);
	clr R16
	xcall _LCD_Dsymbol
	.dbline 1076
; 				LCD_Rsymbol(OFF);
	clr R16
	xcall _LCD_Rsymbol
	.dbline 1077
; 				LCD_Vsymbol(OFF);
	clr R16
	xcall _LCD_Vsymbol
	.dbline 1078
; 				DisplayLCDBuffers();
	xcall _DisplayLCDBuffers
	.dbline 1079
; 				flip = NO;
	clr R10
	.dbline 1080
; 			    }
L304:
	.dbline 1081
; 		    mseccountdown1 = 500;
	ldi R24,500
	ldi R25,1
	sts _mseccountdown1+1,R25
	sts _mseccountdown1,R24
	.dbline 1082
; 			}
L301:
	.dbline 1083
; 			}
L299:
	.dbline 1085
; 			
; 		if(mseccountdown4==0) {
	lds R2,_mseccountdown4
	lds R3,_mseccountdown4+1
	tst R2
	brne L311
	tst R3
	brne L311
X149:
	.dbline 1085
	.dbline 1086
; 		    Adjust_VoltageVolume();
	xcall _Adjust_VoltageVolume
	.dbline 1087
; 			mseccountdown4 = 1;
	ldi R24,1
	ldi R25,0
	sts _mseccountdown4+1,R25
	sts _mseccountdown4,R24
	.dbline 1088
; 			}
L311:
	.dbline 1090
; 		
; 		if(rtccountdown1==0) Display_Count();
	lds R2,_rtccountdown1
	lds R3,_rtccountdown1+1
	tst R2
	brne L313
	tst R3
	brne L313
X150:
	.dbline 1090
	xcall _Display_Count
L313:
	.dbline 1092
; 			
; 		if(mseccountdown2==0) Display_Display_Parameters();
	lds R2,_mseccountdown2
	lds R3,_mseccountdown2+1
	tst R2
	brne L315
	tst R3
	brne L315
X151:
	.dbline 1092
	xcall _Display_Display_Parameters
L315:
	.dbline 1094
; 		   
; 		if(0) {
	xjmp L317
X152:
	.dbline 1097
; 		//if(mseccountdown3==0) {
; 		   SendCharToDisplay(outchar++);
; 		   if(outchar>0x7a) outchar = 0x30;
	ldi R24,48
	mov R14,R24
L319:
	.dbline 1098
; 		   mseccountdown3 = 50;
	ldi R24,50
	ldi R25,0
	sts _mseccountdown3+1,R25
	sts _mseccountdown3,R24
	.dbline 1099
; 		   }
L317:
	.dbline 1101
;    
;    		if(1) {
	.dbline 1101
	.dbline 1102
; 		    if(CheckKeyState(KEY1)) {
	ldi R16,1
	xcall _CheckKeyState
	mov R14,R16
	tst R16
	breq L323
X153:
	.dbline 1102
	.dbline 1103
; 			    line4[8] = 'p';
	ldi R24,112
	sts _line4+8,R24
	.dbline 1104
; 				key1state = ON;
	ldi R24,1
	sts _key1state,R24
	.dbline 1106
; //				Debounce(KEY3);
; 				}
	xjmp L324
L323:
	.dbline 1107
; 			else {
	.dbline 1108
; 			    line4[8] = ' ';
	ldi R24,32
	sts _line4+8,R24
	.dbline 1109
; 				key1state = OFF;
	clr R2
	sts _key1state,R2
	.dbline 1110
; 				}
L324:
	.dbline 1111
; 			if(CheckKeyState(KEY2)) {
	ldi R16,2
	xcall _CheckKeyState
	mov R14,R16
	tst R16
	breq L327
X154:
	.dbline 1111
	.dbline 1112
; 			    line4[9] = 'p';
	ldi R24,112
	sts _line4+9,R24
	.dbline 1113
; 				key2state = ON;
	ldi R24,1
	sts _key2state,R24
	.dbline 1114
; 				LCD_Symbols(OFF);
	clr R16
	xcall _LCD_Symbols
	.dbline 1115
; 				}
	xjmp L328
L327:
	.dbline 1116
; 			else {
	.dbline 1117
; 			    line4[9] = ' ';
	ldi R24,32
	sts _line4+9,R24
	.dbline 1118
; 				key2state = OFF;
	clr R2
	sts _key2state,R2
	.dbline 1119
; 				}
L328:
	.dbline 1120
; 			if(CheckKeyState(KEY3)) {
	ldi R16,3
	xcall _CheckKeyState
	mov R14,R16
	tst R16
	breq L331
X155:
	.dbline 1120
	.dbline 1121
; 			    line4[10] = 'p';
	ldi R24,112
	sts _line4+10,R24
	.dbline 1122
; 				key3state = ON;
	ldi R24,1
	sts _key3state,R24
	.dbline 1123
; 				SplashScreen();
	xcall _SplashScreen
	.dbline 1124
; 				}
	xjmp L332
L331:
	.dbline 1125
; 			else {
	.dbline 1126
; 			    line4[10] = ' ';
	ldi R24,32
	sts _line4+10,R24
	.dbline 1127
; 				key3state = OFF;
	clr R2
	sts _key3state,R2
	.dbline 1128
; 				}
L332:
	.dbline 1129
; 			if(CheckKeyState(KEY4)) {
	ldi R16,4
	xcall _CheckKeyState
	mov R14,R16
	tst R16
	breq L335
X156:
	.dbline 1129
	.dbline 1130
; 			    line4[11] = 'p';
	ldi R24,112
	sts _line4+11,R24
	.dbline 1131
; 				key4state = ON;
	ldi R24,1
	sts _key4state,R24
	.dbline 1132
; 				LCD_Symbols(ON);
	ldi R16,1
	xcall _LCD_Symbols
	.dbline 1133
; 				}
	xjmp L336
L335:
	.dbline 1134
; 			else {
	.dbline 1135
; 			    line4[11] = ' ';
	ldi R24,32
	sts _line4+11,R24
	.dbline 1136
; 				key4state = OFF;
	clr R2
	sts _key4state,R2
	.dbline 1137
; 				}
L336:
	.dbline 1138
; 		}
L321:
	.dbline 1141
; 		   
; 		//  Check Uart RX for display commands
; 		if((inchar=getcharnw())!=0)  ParseChar(inchar);
	xcall _getcharnw
	mov R14,R16
	std y+20,R14
	tst R16
	breq L339
X157:
	.dbline 1141
	xcall _ParseChar
L339:
	.dbline 1144
; 		
; 		//  Check TWI Input for display commands
; 	    if(0) {
	xjmp L341
X158:
	.dbline 1146
; 	    //  See if we need to send anything
; 		if(!TWI_statusReg.dataInTxBuf) {
	.dbline 1147
; 		    messageBuf[0] = inchar++; 
	ldd R10,y+20
	mov R24,R10
	subi R24,255    ; addi 1
	std y+20,R24
	std y+0,R10
	.dbline 1148
; 			messageBuf[1] = inchar++;                            
	ldd R22,y+20
	mov R24,R22
	subi R24,255    ; addi 1
	std y+20,R24
	std y+1,R22
	.dbline 1149
;             TWI_Start_Transceiver_With_Data(messageBuf,2);
	ldi R18,2
	movw R16,R28
	xcall _TWI_Start_Transceiver_With_Data
	.dbline 1150
;             }
L343:
	.dbline 1152
;         // Check if the last TWI operation was a reception
;         if(TWI_statusReg.dataInRxBuf) {
	lds R24,_TWI_statusReg
	lsr R24
	andi R24,1
	breq L346
X159:
	.dbline 1152
	.dbline 1153
;             TWI_Get_Data_From_Transceiver(messageBuf,2);
	ldi R18,2
	movw R16,R28
	xcall _TWI_Get_Data_From_Transceiver
	.dbline 1156
;             // Check if the last operation was a reception as General Call
; 		    // Haven't defined what happens when a general call is received        
;             if(TWI_statusReg.genAddressCall){
	lds R24,_TWI_statusReg
	lsr R24
	lsr R24
	andi R24,1
	breq L348
X160:
	.dbline 1156
	.dbline 1158
;                 // Put data received out to PORTB as an example.                                    
;                 }
	xjmp L349
L348:
	.dbline 1161
; 			 
;             // If not general call must be addressed slave
;             else  {
	.dbline 1163
;                 // TWI_CMD_MASTER_WRITE passes command to command parser
;                 if((messageBuf[0]&0x01)==TWI_CMD_MASTER_WRITE) {  
	ldd R2,y+0
	sbrc R2,0
	rjmp L350
X161:
	.dbline 1163
	.dbline 1164
; 				    inchar = messageBuf[1];
	ldd R2,y+1
	std y+20,R2
	.dbline 1165
; 					ParseChar(inchar);
	mov R16,R2
	xcall _ParseChar
	.dbline 1166
; 					}
L350:
	.dbline 1167
;                 }
L349:
	.dbline 1168
;             }
L346:
	.dbline 1169
; 	      }
L341:
	.dbline 1170
; 	    }
L297:
	.dbline 1051
	xjmp L296
X162:
	.dbline -2
L295:
	.dbline 0 ; func end
	adiw R28,21
	ret
	.dbsym l realnum 16 D
	.dbsym l analogvalue 1 I
	.dbsym l i 1 I
	.dbsym l outstrg 4 A[12:12]c
	.dbsym r voltlevel 14 c
	.dbsym r outbyte 14 c
	.dbsym r symbolptr 14 c
	.dbsym r TWI_slaveAddress 20 c
	.dbsym r symbolindex 12 I
	.dbsym r level2 22 c
	.dbsym r level 20 c
	.dbsym r flip 10 c
	.dbsym l messageBuf 0 A[4:4]c
	.dbsym r outchar 14 c
	.dbsym l inchar 20 c
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\docs\SMARTL~1\SMARTL~1\SmartLCD\SMARTL~1\TinyLCD_Controller.c
_symbolmode::
	.blkb 1
	.dbsym e symbolmode _symbolmode c
_lcdphoneantennasymbols::
	.blkb 1
	.dbsym e lcdphoneantennasymbols _lcdphoneantennasymbols c
_escmode::
	.blkb 1
	.dbsym e escmode _escmode c
_lineptr::
	.blkb 1
	.dbsym e lineptr _lineptr c
_colptr::
	.blkb 1
	.dbsym e colptr _colptr c
_rowptr::
	.blkb 1
	.dbsym e rowptr _rowptr c
_cursormax::
	.blkb 1
	.dbsym e cursormax _cursormax c
_cursorposition::
	.blkb 1
	.dbsym e cursorposition _cursorposition c
_line4::
	.blkb 13
	.dbsym e line4 _line4 A[13:13]c
_line3::
	.blkb 13
	.dbsym e line3 _line3 A[13:13]c
_line2::
	.blkb 13
	.dbsym e line2 _line2 A[13:13]c
_line1::
	.blkb 13
	.dbsym e line1 _line1 A[13:13]c
_flip2::
	.blkb 1
	.dbsym e flip2 _flip2 c
_lcdstate::
	.blkb 1
	.dbsym e lcdstate _lcdstate c
_lcdchiptype::
	.blkb 1
	.dbsym e lcdchiptype _lcdchiptype c
_numstrg::
	.blkb 9
	.dbsym e numstrg _numstrg A[9:9]c
_count::
	.blkb 2
	.dbsym e count _count i
_totalrxcnt::
	.blkb 2
	.dbsym e totalrxcnt _totalrxcnt i
_oldbyteoffset::
	.blkb 2
	.dbsym e oldbyteoffset _oldbyteoffset i
_oldpage::
	.blkb 2
	.dbsym e oldpage _oldpage i
_intelsuperaddress::
	.blkb 2
	.dbsym e intelsuperaddress _intelsuperaddress i
_TWI_statusReg::
	.blkb 1
	.dbstruct 0 1 TWI_S_statusReg
	.dbfield 0 dataInTxBuf F[0:1]
	.dbfield 0 dataInRxBuf F[1:1]
	.dbfield 0 genAddressCall F[2:1]
	.dbfield 0 RxBufOverflow F[3:1]
	.dbfield 0 TxBufOverflow F[4:1]
	.dbfield 0 unused F[5:3]
	.dbend
	.dbsym e TWI_statusReg _TWI_statusReg S[TWI_S_statusReg]
_FlashAddress::
	.blkb 3
	.dbsym e FlashAddress _FlashAddress A[3:3]c
_key4toggle::
	.blkb 1
	.dbsym e key4toggle _key4toggle c
_key3toggle::
	.blkb 1
	.dbsym e key3toggle _key3toggle c
_key2toggle::
	.blkb 1
	.dbsym e key2toggle _key2toggle c
_key1toggle::
	.blkb 1
	.dbsym e key1toggle _key1toggle c
_key4state::
	.blkb 1
	.dbsym e key4state _key4state c
_key3state::
	.blkb 1
	.dbsym e key3state _key3state c
_key2state::
	.blkb 1
	.dbsym e key2state _key2state c
_key1state::
	.blkb 1
	.dbsym e key1state _key1state c
_hexbyte::
	.blkb 3
	.dbsym e hexbyte _hexbyte A[3:3]c
_vhigh::
	.blkb 1
	.dbsym e vhigh _vhigh c
_vlow::
	.blkb 1
	.dbsym e vlow _vlow c
_instrg::
	.blkb 8
	.dbsym e instrg _instrg A[8:8]c
_rxcntmax::
	.blkb 1
	.dbsym e rxcntmax _rxcntmax c
_checkflag::
	.blkb 1
	.dbsym e checkflag _checkflag c
_rxcnt::
	.blkb 1
	.dbsym e rxcnt _rxcnt c
_sendxoff::
	.blkb 1
	.dbsym e sendxoff _sendxoff c
_echoinchars::
	.blkb 1
	.dbsym e echoinchars _echoinchars c
_enablexonoff::
	.blkb 1
	.dbsym e enablexonoff _enablexonoff c
_xonsent::
	.blkb 1
	.dbsym e xonsent _xonsent c
_xoffsent::
	.blkb 1
	.dbsym e xoffsent _xoffsent c
_UART_TxTail::
	.blkb 1
	.dbsym e UART_TxTail _UART_TxTail c
_UART_TxHead::
	.blkb 1
	.dbsym e UART_TxHead _UART_TxHead c
_UART_TxBuf::
	.blkb 64
	.dbsym e UART_TxBuf _UART_TxBuf A[64:64]c
_UART_RxTail::
	.blkb 1
	.dbsym e UART_RxTail _UART_RxTail c
_UART_RxHead::
	.blkb 1
	.dbsym e UART_RxHead _UART_RxHead c
_UART_RxBuf::
	.blkb 64
	.dbsym e UART_RxBuf _UART_RxBuf A[64:64]c
_rtcclockcnt::
	.blkb 1
	.dbsym e rtcclockcnt _rtcclockcnt c
_voltagevolume::
	.blkb 1
	.dbsym e voltagevolume _voltagevolume c
_dataoverrun::
	.blkb 1
	.dbsym e dataoverrun _dataoverrun c
_frameerror::
	.blkb 1
	.dbsym e frameerror _frameerror c
_xoffcnt::
	.blkb 2
	.dbsym e xoffcnt _xoffcnt i
_xoncnt::
	.blkb 2
	.dbsym e xoncnt _xoncnt i
_totalbytecnt::
	.blkb 2
	.dbsym e totalbytecnt _totalbytecnt i
_days::
	.blkb 2
	.dbsym e days _days i
_hours::
	.blkb 2
	.dbsym e hours _hours i
_minutes::
	.blkb 2
	.dbsym e minutes _minutes i
_seconds::
	.blkb 2
	.dbsym e seconds _seconds i
_mseccountdown5::
	.blkb 2
	.dbsym e mseccountdown5 _mseccountdown5 i
_mseccountdown4::
	.blkb 2
	.dbsym e mseccountdown4 _mseccountdown4 i
_mseccountdown3::
	.blkb 2
	.dbsym e mseccountdown3 _mseccountdown3 i
_mseccountdown2::
	.blkb 2
	.dbsym e mseccountdown2 _mseccountdown2 i
_mseccountdown1::
	.blkb 2
	.dbsym e mseccountdown1 _mseccountdown1 i
_rtccountdown4::
	.blkb 2
	.dbsym e rtccountdown4 _rtccountdown4 i
_rtccountdown3::
	.blkb 2
	.dbsym e rtccountdown3 _rtccountdown3 i
_rtccountdown2::
	.blkb 2
	.dbsym e rtccountdown2 _rtccountdown2 i
_rtccountdown1::
	.blkb 2
	.dbsym e rtccountdown1 _rtccountdown1 i
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\docs\SMARTL~1\SMARTL~1\SmartLCD\SMARTL~1\TinyLCD_Controller.c
L293:
	.blkb 7
	.area idata
	.byte 'c,'o,'u,'n,'t,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\docs\SMARTL~1\SMARTL~1\SmartLCD\SMARTL~1\TinyLCD_Controller.c
L282:
	.blkb 2
	.area idata
	.byte 58,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\docs\SMARTL~1\SMARTL~1\SmartLCD\SMARTL~1\TinyLCD_Controller.c
L277:
	.blkb 9
	.area idata
	.byte 'A,'n,'a,'l,'o,'g,48,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\docs\SMARTL~1\SMARTL~1\SmartLCD\SMARTL~1\TinyLCD_Controller.c
L275:
	.blkb 8
	.area idata
	.byte 'V,'o,'l,'t,32,'v,61,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\Steve\Desktop\Billys_files\docs\SMARTL~1\SMARTL~1\SmartLCD\SMARTL~1\TinyLCD_Controller.c
; }
