	.module SmartLCD_Accelerometer.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\SMARTL~1\SMARTL~1\SmartLCD_g\TINYLC~1\SmartLCD_Accelerometer.c
	.dbfunc e setAccelerometerRange _setAccelerometerRange fV
;          range -> R16
	.even
_setAccelerometerRange::
	.dbline -1
	.dbline 66
; /**************************************************************
; 
;    Program Title: SmartLCD Controller 
;    
;    Program Name: SmartLCD_Accelerometer.c 		  Version: 0.01
;    
;    Author:  WR	  		  Date:  Febuary 27, 2008
;    
;    Compiled with ImageCraft ICCAVR Standard V7.1
;    
;    Copyright 2004-2008, SOC Machines, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright (C) 2008 by SOC Machines, Inc. All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-machines.com
;  */
; 
; #include "TinyLCD_Uart.h"
; #include <iom168v.h>
; #include <stdlib.h>
; #include "TinyLCD_Extern.h"
; #include "TinyLCD_Defines.h"
; #include "SmartLCD_Accelerometer.h"
; 
; 
; int sensitivity;
;  
; /*
; ACCELEROMETER_1g5 -> 1.5g range 
; ACCELEROMETER_2g -> 3g range 
; ACCELEROMETER_4g -> 4g range 
; ACCELEROMETER_6g -> 6g range 
;  */
;  
; void setAccelerometerRange(unsigned char range)
; {
	.dbline 67
; 	if (range == ACCELEROMETER_1g5)
	tst R16
	brne L2
X0:
	.dbline 68
; 	{
	.dbline 69
; 	   	  ACCELEROMETER_CONTROL &= ~((1<<GS1)|(1<<GS2));//clear GS1 and GS2
	in R24,0x5
	andi R24,231
	out 0x5,R24
	.dbline 70
; 		  sensitivity = ACCELEROMETER_1g5_SENSITIVITY;
	ldi R24,800
	ldi R25,3
	sts _sensitivity+1,R25
	sts _sensitivity,R24
	.dbline 71
; 	}
	xjmp L3
L2:
	.dbline 72
; 	else if (range == ACCELEROMETER_2g)
	cpi R16,1
	brne L4
X1:
	.dbline 73
; 	{
	.dbline 74
; 		  ACCELEROMETER_CONTROL &= ~(1<<GS2);//clear GS2
	cbi 0x5,4
	.dbline 75
; 		  ACCELEROMETER_CONTROL |= (1<<GS1);//set GS1
	sbi 0x5,3
	.dbline 76
; 		  sensitivity = ACCELEROMETER_2g_SENSITIVITY;
	ldi R24,600
	ldi R25,2
	sts _sensitivity+1,R25
	sts _sensitivity,R24
	.dbline 77
; 	}
	xjmp L5
L4:
	.dbline 78
; 	else if (range == ACCELEROMETER_4g)
	cpi R16,2
	brne L6
X2:
	.dbline 79
; 	{
	.dbline 80
; 		  ACCELEROMETER_CONTROL &= ~(1<<GS1);//Clear GS1
	cbi 0x5,3
	.dbline 81
; 		  ACCELEROMETER_CONTROL |= (1<<GS2);//Set GS2
	sbi 0x5,4
	.dbline 82
; 		  sensitivity = ACCELEROMETER_4g_SENSITIVITY;
	ldi R24,300
	ldi R25,1
	sts _sensitivity+1,R25
	sts _sensitivity,R24
	.dbline 83
; 	}
	xjmp L7
L6:
	.dbline 84
; 	else if (range == ACCELEROMETER_6g)
	cpi R16,3
	brne L8
X3:
	.dbline 85
; 	{
	.dbline 86
; 	 	  ACCELEROMETER_CONTROL |= ((1<<GS1)|(1<<GS2));//Set GS1 & GS2
	in R24,0x5
	ori R24,24
	out 0x5,R24
	.dbline 87
; 		  sensitivity = ACCELEROMETER_6g_SENSITIVITY;
	ldi R24,200
	ldi R25,0
	sts _sensitivity+1,R25
	sts _sensitivity,R24
	.dbline 88
; 	}
L8:
L7:
L5:
L3:
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r range 16 c
	.dbend
	.dbfunc e enableAccelerometer _enableAccelerometer fV
;          sleep -> R16
	.even
_enableAccelerometer::
	.dbline -1
	.dbline 92
; }
; 
; void enableAccelerometer(unsigned char sleep)
; {
	.dbline 93
;  	 if(sleep == OFF){	  
	tst R16
	brne L11
X4:
	.dbline 93
	.dbline 94
; 	 		  ACCELEROMETER_CONTROL &= ~(1<<SLEEP); // Disable Accelerometer
	cbi 0x5,5
	.dbline 95
; 	 }
	xjmp L12
L11:
	.dbline 97
; 	 else
; 	 {
	.dbline 98
; 	  	 	  ACCELEROMETER_CONTROL |= (1<<SLEEP); // Enable Accelerometer
	sbi 0x5,5
	.dbline 99
; 	 }
L12:
	.dbline -2
L10:
	.dbline 0 ; func end
	ret
	.dbsym r sleep 16 c
	.dbend
	.dbfunc e readAccelerometer _readAccelerometer fI
;          value -> R10,R11
;           axis -> R20
	.even
_readAccelerometer::
	xcall push_xgset303C
	mov R20,R16
	.dbline -1
	.dbline 104
; }
; 
; 
; int readAccelerometer(unsigned char axis)
; {
	.dbline 105
;  	int value = 0;
	clr R10
	clr R11
	.dbline 107
; 	
;  	if(axis == X_AXIS)  {
	tst R20
	brne L14
X5:
	.dbline 107
	.dbline 108
; 		value = Read_ADC(0x01, ADCEXTERNAL );// ADC1
	ldi R18,1
	ldi R16,1
	xcall _Read_ADC
	movw R10,R16
	.dbline 109
; 		}
	xjmp L15
L14:
	.dbline 110
; 	else if(axis == Y_AXIS) {
	cpi R20,1
	brne L16
X6:
	.dbline 110
	.dbline 111
; 	    value = Read_ADC(0x06, ADCEXTERNAL);  //  ADC6
	ldi R18,1
	ldi R16,6
	xcall _Read_ADC
	movw R10,R16
	.dbline 112
; 	    }
	xjmp L17
L16:
	.dbline 113
; 	else if(axis == Z_AXIS) {
	cpi R20,2
	brne L18
X7:
	.dbline 113
	.dbline 114
; 	    value = Read_ADC(0x07, ADCEXTERNAL); //  ADC7
	ldi R18,1
	ldi R16,7
	xcall _Read_ADC
	movw R12,R16
	movw R10,R12
	.dbline 116
; 		
; 	    }
L18:
L17:
L15:
	.dbline 118
; 
; 	return value;
	movw R16,R10
	.dbline -2
L13:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r value 10 I
	.dbsym r axis 20 c
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\SMARTL~1\SMARTL~1\SmartLCD_g\TINYLC~1\SmartLCD_Accelerometer.c
_sensitivity::
	.blkb 2
	.dbsym e sensitivity _sensitivity I
; }
; 
