	.module TinyLCD_Utilities.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\SMARTL~1\SMARTL~1\SmartLCD_g\TINYLC~1\TinyLCD_Utilities.c
	.dbfunc e Delay _Delay fV
;              a -> R16
;              b -> R18
	.even
_Delay::
	.dbline -1
	.dbline 74
; /**************************************************************
; 
;    Program Title:  TinyLCD Controller
;    
;    Program Name:  TinyLCD_Utilities.c	  Version: 0.86
;    
;    Author:  SS/WR	  					  Date:  February 29, 2008
;    
;    Compiled with ImageCraft ICCAVR Standard V7.02
;    
;    This file contains routines that implement a set of basic utility
;    functions for the TinyLCD controller.
;    
;    Copyright 2004-2008, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2008, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC MACHINES, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: TinyLCD_Utilities.c,v $
;  * Revision 0.86  2006/02/07  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom168v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; //#include <stdio.h>
; #include "TinyLCD_Uart.h"
; #include "TinyLCD_Defines.h"
; #include "TinyLCD_Extern.h"
; 
; //*********************************************************
; //*********************************************************
; //      Utilities
; //*********************************************************
; //*********************************************************
; void Delay(void)
; {
	.dbline 77
; 	unsigned char a, b;
; 
; 	for (a = 1; a; a++)
	ldi R16,1
	xjmp L5
L2:
	.dbline 78
; 		for (b = 1; b; b++)
	ldi R18,1
	xjmp L9
L6:
	.dbline 79
; 			;
L7:
	.dbline 78
	inc R18
L9:
	.dbline 78
	tst R18
	brne L6
X0:
L3:
	.dbline 77
	inc R16
L5:
	.dbline 77
	tst R16
	brne L2
X1:
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r a 16 c
	.dbsym r b 18 c
	.dbend
	.dbfunc e ShortDelay _ShortDelay fV
;         inbyte -> R22
;              i -> R20,R21
;            cnt -> R16,R17
	.even
_ShortDelay::
	xcall push_xgsetF000
	.dbline -1
	.dbline 83
; }
; 
; void ShortDelay(int cnt)
; {
	.dbline 87
;  	unsigned char inbyte;
; 	int i;
; 	
;     for(i=0; i<cnt; i++)  {
	clr R20
	clr R21
	xjmp L14
L11:
	.dbline 87
	.dbline 88
; 	    inbyte = 0x55;
	ldi R22,85
	.dbline 89
; 		}
L12:
	.dbline 87
	subi R20,255  ; offset = 1
	sbci R21,255
L14:
	.dbline 87
	cp R20,R16
	cpc R21,R17
	brlt L11
X2:
	.dbline -2
L10:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 22 c
	.dbsym r i 20 I
	.dbsym r cnt 16 I
	.dbend
	.dbfunc e LongDelay _LongDelay fV
;            cnt -> R20,R21
	.even
_LongDelay::
	st -y,R20
	st -y,R21
	movw R20,R16
	.dbline -1
	.dbline 93
; }
; 
; void LongDelay(int cnt)
; {
	xjmp L17
L16:
	.dbline 94
;  	 while(cnt > 0) {
	.dbline 95
; 	 	 Delay();
	xcall _Delay
	.dbline 96
; 		 cnt--;
	subi R20,1
	sbci R21,0
	.dbline 97
; 		 }
L17:
	.dbline 94
	clr R2
	clr R3
	cp R2,R20
	cpc R3,R21
	brlt L16
X3:
	.dbline -2
L15:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r cnt 20 I
	.dbend
	.dbfunc e Delaymsec _Delaymsec fV
;     delayvalue -> R16,R17
	.even
_Delaymsec::
	.dbline -1
	.dbline 101
; }
; 
; void Delaymsec(int delayvalue)
; {
	.dbline 102
;  	 mseccountdown2 = delayvalue;
	sts _mseccountdown2+1,R17
	sts _mseccountdown2,R16
L20:
	.dbline 103
; 	 while(mseccountdown2) ;
L21:
	.dbline 103
	lds R2,_mseccountdown2
	lds R3,_mseccountdown2+1
	tst R2
	brne L20
	tst R3
	brne L20
X4:
	.dbline -2
L19:
	.dbline 0 ; func end
	ret
	.dbsym r delayvalue 16 I
	.dbend
	.dbfunc e RTEEPROMwrite _RTEEPROMwrite fV
;      savedSREG -> R10
;       databyte -> R18
;       location -> R16,R17
	.even
_RTEEPROMwrite::
	st -y,R10
	.dbline -1
	.dbline 110
; }
; 
; // Function to initiate an EEPROM write
; // writes the specified data byte to the specified location
; // this will fail if the EEPROM is not ready!
; void RTEEPROMwrite(int location, unsigned char databyte)
; {
	.dbline 112
; 	unsigned char savedSREG;
; 	EEAR = location;								// set address
	out 0x22,R17
	out 0x21,R16
	.dbline 113
; 	EEDR = databyte;								// set data	
	out 0x20,R18
	.dbline 114
; 	savedSREG = SREG;								// keep setting so it can be restored
	in R10,0x3f
	.dbline 115
; 	CLI();													// disable interrupts
	cli
	.dbline 116
; 	EECR |= BIT(EEMWE);							// set "write enable" bit
	sbi 0x1f,2
	.dbline 117
; 	EECR |= BIT(EEWE);							// set "write" bit
	sbi 0x1f,1
	.dbline 118
; 	SREG = savedSREG;								// restore SREG
	out 0x3f,R10
	.dbline 119
; 	EEAR = 0;
	clr R2
	clr R3
	out 0x22,R3
	out 0x21,R2
	.dbline -2
L23:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r savedSREG 10 c
	.dbsym r databyte 18 c
	.dbsym r location 16 I
	.dbend
	.dbfunc e EEPROMWrite _EEPROMWrite fV
;       databyte -> R12
;       location -> R10,R11
	.even
_EEPROMWrite::
	xcall push_xgset003C
	mov R12,R18
	movw R10,R16
	.dbline -1
	.dbline 125
; }
; 
; // EEPROM writes take about 8ms - so poll until done
; // Do not use ICC V7 function EEPROMwrite() - this routine turns interrupts off!
; void EEPROMWrite(int location, unsigned char databyte)
; {
L25:
	.dbline 126
;  	 while(!RTEEPROMReady())  ;
L26:
	.dbline 126
	xcall _RTEEPROMReady
	cpi R16,0
	cpc R16,R17
	breq L25
X5:
	.dbline 127
;  	 RTEEPROMwrite(location,databyte);
	mov R18,R12
	movw R16,R10
	xcall _RTEEPROMwrite
L28:
	.dbline 128
;  	 while(!RTEEPROMReady())  ;
L29:
	.dbline 128
	xcall _RTEEPROMReady
	cpi R16,0
	cpc R16,R17
	breq L28
X6:
	.dbline -2
L24:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.dbsym r databyte 12 c
	.dbsym r location 10 I
	.dbend
	.dbfunc e hextobyte _hextobyte fc
;         inbyte -> R16
	.even
_hextobyte::
	xcall push_xgsetF000
	.dbline -1
	.dbline 132
; }
; 
; unsigned char hextobyte(unsigned char inbyte)
; {
	.dbline 133
; 	 if((inbyte >= 'A')&(inbyte<='F')) return (inbyte - 'A' + 10);
	cpi R16,65
	brlo L34
X7:
	ldi R22,1
	ldi R23,0
	xjmp L35
L34:
	clr R22
	clr R23
L35:
	ldi R24,70
	cp R24,R16
	brlo L36
X8:
	ldi R20,1
	ldi R21,0
	xjmp L37
L36:
	clr R20
	clr R21
L37:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X9
	tst R3
	breq L32
X9:
	.dbline 133
	mov R24,R16
	subi R24,65
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L31
L32:
	.dbline 134
; 	 if((inbyte >= 'a')&(inbyte<='f')) return (inbyte - 'a' + 10);
	cpi R16,97
	brlo L40
X10:
	ldi R22,1
	ldi R23,0
	xjmp L41
L40:
	clr R22
	clr R23
L41:
	ldi R24,102
	cp R24,R16
	brlo L42
X11:
	ldi R20,1
	ldi R21,0
	xjmp L43
L42:
	clr R20
	clr R21
L43:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X12
	tst R3
	breq L38
X12:
	.dbline 134
	mov R24,R16
	subi R24,97
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L31
L38:
	.dbline 135
; 	 else return (inbyte - '0');
	subi R16,48
	.dbline -2
L31:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 16 c
	.dbend
	.dbfunc e bytetohex _bytetohex fV
;         inchar -> <dead>
;         inbyte -> R20
;           byte -> R16
	.even
_bytetohex::
	st -y,R20
	.dbline -1
	.dbline 140
; }
; 
; //  Convert byte to ASCII hex
; void bytetohex(unsigned char byte)
; {
	.dbline 143
;     unsigned char inbyte,inchar;
; 	
; 	inbyte = byte & 0x0f;
	mov R20,R16
	andi R20,15
	.dbline 144
; 	if(inbyte > 9) hexbyte[1] = (inbyte - 9) + 0x40;
	ldi R24,9
	cp R24,R20
	brsh L45
X13:
	.dbline 144
	mov R24,R20
	subi R24,9
	subi R24,192    ; addi 64
	sts _hexbyte+1,R24
	xjmp L46
L45:
	.dbline 145
; 	else hexbyte[1] = 0x30 + inbyte;
	mov R24,R20
	subi R24,208    ; addi 48
	sts _hexbyte+1,R24
L46:
	.dbline 146
; 	inbyte = byte & 0xf0;
	mov R20,R16
	andi R20,240
	.dbline 147
; 	inbyte >>= 4;
	mov R24,R20
	swap R24
	andi R24,#0x0F
	mov R20,R24
	.dbline 148
; 	if(inbyte >9) hexbyte[0] = (inbyte - 9) + 0x40;
	ldi R24,9
	cp R24,R20
	brsh L49
X14:
	.dbline 148
	mov R24,R20
	subi R24,9
	subi R24,192    ; addi 64
	sts _hexbyte,R24
	xjmp L50
L49:
	.dbline 149
; 	else hexbyte[0] = 0x30 + inbyte;
	mov R24,R20
	subi R24,208    ; addi 48
	sts _hexbyte,R24
L50:
	.dbline 150
;     hexbyte[2] = 0x00;
	clr R2
	sts _hexbyte+2,R2
	.dbline -2
L44:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym l inchar 1 c
	.dbsym r inbyte 20 c
	.dbsym r byte 16 c
	.dbend
	.dbfunc e RTEEPROMReady _RTEEPROMReady fc
	.even
_RTEEPROMReady::
	.dbline -1
	.dbline 158
; }
; 
; 
; 
; // function to test if the EEPROM is ready for a read or write operation
; // returns non zero if ready, zero if not ready 
; unsigned char RTEEPROMReady(void)
; {
	.dbline 159
; 	return !(EECR & 0x02);
	sbic 0x1f,1
	rjmp L53
X15:
	ldi R16,1
	ldi R17,0
	xjmp L54
L53:
	clr R16
	clr R17
L54:
	.dbline -2
L52:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LED_Power _LED_Power fV
;          state -> R16
	.even
_LED_Power::
	.dbline -1
	.dbline 163
; }
; 
; void LED_Power(unsigned char state)
; {
	.dbline 164
;  	 if(state==ON)  ClrBit(PORTD,PIND5);
	cpi R16,1
	brne L56
X16:
	.dbline 164
	cbi 0xb,5
	xjmp L57
L56:
	.dbline 165
; 	 else  SetBit(PORTD,PIND5);
	sbi 0xb,5
L57:
	.dbline -2
L55:
	.dbline 0 ; func end
	ret
	.dbsym r state 16 c
	.dbend
	.dbfunc e LCD_LED_Power _LCD_LED_Power fV
;          state -> R16
	.even
_LCD_LED_Power::
	.dbline -1
	.dbline 169
; }
; 
; void LCD_LED_Power(unsigned char state)
; {
	.dbline 170
;  	 if(state==ON)  SetBit(PORTD,PIND6);
	cpi R16,1
	brne L59
X17:
	.dbline 170
	sbi 0xb,6
	xjmp L60
L59:
	.dbline 171
; 	 else  ClrBit(PORTD,PIND6);
	cbi 0xb,6
L60:
	.dbline -2
L58:
	.dbline 0 ; func end
	ret
	.dbsym r state 16 c
	.dbend
	.dbfunc e CheckKeyState _CheckKeyState fc
;          inkey -> R20
;            key -> R16
	.even
_CheckKeyState::
	st -y,R20
	.dbline -1
	.dbline 177
; }
; 
; // Key 1 is far left Key 4 is far right
; // Key pressed is active low
; unsigned char CheckKeyState(unsigned char key)
; {
	.dbline 180
;  	unsigned char inkey;
; 	
;  	if(key==KEY1) inkey = PIND&0x04;
	cpi R16,1
	brne L62
X18:
	.dbline 180
	in R20,0x9
	andi R20,4
	xjmp L63
L62:
	.dbline 181
; 	else if(key==KEY2) inkey = PIND&0x08;
	cpi R16,2
	brne L64
X19:
	.dbline 181
	in R20,0x9
	andi R20,8
	xjmp L65
L64:
	.dbline 182
; 	else if(key==KEY3) inkey = PIND&0x10;
	cpi R16,3
	brne L66
X20:
	.dbline 182
	in R20,0x9
	andi R20,16
	xjmp L67
L66:
	.dbline 183
; 	else if(key==KEY4) inkey = PIND&0x80;
	cpi R16,4
	brne L68
X21:
	.dbline 183
	in R20,0x9
	andi R20,128
	xjmp L69
L68:
	.dbline 184
; 	else return 1;
	ldi R16,1
	xjmp L61
L69:
L67:
L65:
L63:
	.dbline 185
; 	if(inkey>0) return 0;
	ldi R24,0
	cp R24,R20
	brsh L70
X22:
	.dbline 185
	clr R16
	xjmp L61
L70:
	.dbline 186
; 	else return 1;
	ldi R16,1
	.dbline -2
L61:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r inkey 20 c
	.dbsym r key 16 c
	.dbend
	.dbfunc e ToggleKeyState _ToggleKeyState fV
;            key -> R16
	.even
_ToggleKeyState::
	.dbline -1
	.dbline 190
; }
; 
; void ToggleKeyState(char key)
; {
	.dbline 191
;  	 if(key==1) {
	cpi R16,1
	brne L73
X23:
	.dbline 191
	.dbline 192
; 	     if(key1toggle==1) key1toggle = 0;
	lds R24,_key1toggle
	cpi R24,1
	brne L75
X24:
	.dbline 192
	clr R2
	sts _key1toggle,R2
	xjmp L76
L75:
	.dbline 193
; 		 else key1toggle = 1;
	ldi R24,1
	sts _key1toggle,R24
L76:
	.dbline 194
; 		 }
L73:
	.dbline 195
;  	 if(key==2) {
	cpi R16,2
	brne L77
X25:
	.dbline 195
	.dbline 196
; 	     if(key2toggle==1) key2toggle = 0;
	lds R24,_key2toggle
	cpi R24,1
	brne L79
X26:
	.dbline 196
	clr R2
	sts _key2toggle,R2
	xjmp L80
L79:
	.dbline 197
; 		 else key2toggle = 1;
	ldi R24,1
	sts _key2toggle,R24
L80:
	.dbline 198
; 		 }
L77:
	.dbline 199
;  	 if(key==3) {
	cpi R16,3
	brne L81
X27:
	.dbline 199
	.dbline 200
; 	     if(key3toggle==1) key3toggle = 0;
	lds R24,_key3toggle
	cpi R24,1
	brne L83
X28:
	.dbline 200
	clr R2
	sts _key3toggle,R2
	xjmp L84
L83:
	.dbline 201
; 		 else key3toggle = 1;
	ldi R24,1
	sts _key3toggle,R24
L84:
	.dbline 202
; 		 }
L81:
	.dbline 203
;  	 if(key==4) {
	cpi R16,4
	brne L85
X29:
	.dbline 203
	.dbline 204
; 	     if(key4toggle==1) key4toggle = 0;
	lds R24,_key4toggle
	cpi R24,1
	brne L87
X30:
	.dbline 204
	clr R2
	sts _key4toggle,R2
	xjmp L88
L87:
	.dbline 205
; 		 else key4toggle = 1;
	ldi R24,1
	sts _key4toggle,R24
L88:
	.dbline 206
; 		 }
L85:
	.dbline -2
L72:
	.dbline 0 ; func end
	ret
	.dbsym r key 16 c
	.dbend
	.dbfunc e Read_ADC _Read_ADC fI
;           high -> R12
;            low -> R10
;            ref -> R22
;        channel -> R20
	.even
_Read_ADC::
	xcall push_xgsetF03C
	mov R22,R18
	mov R20,R16
	.dbline -1
	.dbline 211
; }
; 
; 
; int Read_ADC(unsigned char channel, unsigned char ref)
; {
	.dbline 214
;  	unsigned char low,high;
; 	
; 	if (ref == ADCINTERNAL)
	tst R22
	brne L90
X31:
	.dbline 215
; 	{
	.dbline 216
; 	 ADMUX = 0xC0;//internal reference
	ldi R24,192
	sts 124,R24
	.dbline 217
; 	} else if (ref == ADCEXTERNAL)
	xjmp L91
L90:
	.dbline 217
	cpi R22,1
	brne L92
X32:
	.dbline 218
; 	{
	.dbline 219
; 	  ADMUX = 0x40;//AVCC is our reference
	ldi R24,64
	sts 124,R24
	.dbline 220
; 	} else return 0;
	xjmp L93
L92:
	.dbline 220
	clr R16
	clr R17
	xjmp L89
L93:
L91:
	.dbline 222
; 	//As the voltage reference has been changed we ignore the first value read
; 	ADCSRA = (1<<ADEN)|(1<<ADSC);
	ldi R24,192
	sts 122,R24
L94:
	.dbline 223
; 	while(!(ADCSRA&(1<<ADIF))) ;  // wait for adc to complete
L95:
	.dbline 223
	lds R2,122
	sbrs R2,4
	rjmp L94
X33:
	.dbline 224
; 	Delay();
	xcall _Delay
	.dbline 229
; 	
; 	
; 	
; 	
;  	if(channel==0)  {
	tst R20
	brne L97
X34:
	.dbline 229
	.dbline 231
; 	    //Already set to channel 0  //  ADC0
; 		ADCSRA = (1<<ADEN)|(1<<ADSC);
	ldi R24,192
	sts 122,R24
	.dbline 232
; 		}
	xjmp L106
L97:
	.dbline 233
; 	else if(channel==1) {
	cpi R20,1
	brne L99
X35:
	.dbline 233
	.dbline 234
; 	    ADMUX |= 0x01;   //  ADC1
	lds R24,124
	ori R24,1
	sts 124,R24
	.dbline 235
; 		ADCSRA = (1<<ADEN)|(1<<ADSC);
	ldi R24,192
	sts 122,R24
	.dbline 236
; 	    }	
	xjmp L106
L99:
	.dbline 237
; 	else if(channel==6) {
	cpi R20,6
	brne L101
X36:
	.dbline 237
	.dbline 238
; 	    ADMUX |= 0x06;   //  ADC6
	lds R24,124
	ori R24,6
	sts 124,R24
	.dbline 239
; 		ADCSRA = (1<<ADEN)|(1<<ADSC);
	ldi R24,192
	sts 122,R24
	.dbline 240
; 	    }
	xjmp L106
L101:
	.dbline 241
; 	else if(channel==7) {
	cpi R20,7
	brne L103
X37:
	.dbline 241
	.dbline 242
; 	    ADMUX |= 0x07;   //  ADC7
	lds R24,124
	ori R24,7
	sts 124,R24
	.dbline 243
; 		ADCSRA = (1<<ADEN)|(1<<ADSC);
	ldi R24,192
	sts 122,R24
	.dbline 244
; 	    }
	xjmp L106
L103:
	.dbline 245
; 	else return 0;
	clr R16
	clr R17
	xjmp L89
L105:
	.dbline 247
; 	
; 	while(!(ADCSRA&(1<<ADIF))) ;  // wait for adc to complete
L106:
	.dbline 247
	lds R2,122
	sbrs R2,4
	rjmp L105
X38:
	.dbline 248
; 	Delay();
	xcall _Delay
	.dbline 249
; 	low = ADCL;
	lds R10,120
	.dbline 250
; 	high = ADCH;
	lds R12,121
	.dbline 251
; 	return (low+high*256);
	mov R18,R12
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	movw R2,R16
	mov R16,R10
	clr R17
	add R16,R2
	adc R17,R3
	.dbline -2
L89:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
	.dbsym r high 12 c
	.dbsym r low 10 c
	.dbsym r ref 22 c
	.dbsym r channel 20 c
	.dbend
	.dbfunc e printint _printint fV
;           tens -> R12,R13
;       hundreds -> R14,R15
;      thousands -> R22,R23
;   tenthousands -> R10,R11
;              i -> R20,R21
;           text -> y+12
;       intvalue -> y+10
	.even
_printint::
	xcall push_arg4
	xcall push_xgsetF0FC
	.dbline -1
	.dbline 256
; }
; 
; 
; void printint(int intvalue, unsigned char *text)
; {
	.dbline 258
;  	
; 	 int tenthousands, thousands, hundreds, tens,i = 0;
	clr R20
	clr R21
	.dbline 260
; 	 
; 	 if(intvalue < 0)
	ldd R24,y+10
	ldd R25,y+11
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brge L109
X39:
	.dbline 261
; 	 {
	.dbline 263
; 	  			 
; 				text[i] = '-';
	movw R30,R20
	ldd R0,y+12
	ldd R1,y+13
	add R30,R0
	adc R31,R1
	ldi R24,45
	std z+0,R24
	.dbline 264
; 				i++;
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 265
; 				intvalue *= -1;
	ldi R16,-1
	ldi R17,-1
	ldd R18,y+10
	ldd R19,y+11
	xcall empy16s
	std y+11,R17
	std y+10,R16
	.dbline 266
; 	 } 
L109:
	.dbline 268
; 
; 	 tenthousands = intvalue/10000;
	ldi R18,10000
	ldi R19,39
	ldd R16,y+10
	ldd R17,y+11
	xcall div16s
	movw R10,R16
	.dbline 269
; 	 intvalue -= (tenthousands*10000);
	ldi R16,10000
	ldi R17,39
	movw R18,R10
	xcall empy16s
	ldd R0,y+10
	ldd R1,y+11
	sub R0,R16
	sbc R1,R17
	std y+11,R1
	std y+10,R0
	.dbline 270
; 	 thousands = intvalue/1000;
	ldi R18,1000
	ldi R19,3
	movw R16,R0
	xcall div16s
	movw R22,R16
	.dbline 271
; 	 intvalue -= (thousands*1000);
	ldi R16,1000
	ldi R17,3
	movw R18,R22
	xcall empy16s
	ldd R0,y+10
	ldd R1,y+11
	sub R0,R16
	sbc R1,R17
	std y+11,R1
	std y+10,R0
	.dbline 272
; 	 hundreds = intvalue/100;
	ldi R18,100
	ldi R19,0
	movw R16,R0
	xcall div16s
	movw R14,R16
	.dbline 273
; 	 intvalue -= (hundreds*100);
	ldi R16,100
	ldi R17,0
	movw R18,R14
	xcall empy16s
	ldd R0,y+10
	ldd R1,y+11
	sub R0,R16
	sbc R1,R17
	std y+11,R1
	std y+10,R0
	.dbline 274
; 	 tens = intvalue/10;
	ldi R18,10
	ldi R19,0
	movw R16,R0
	xcall div16s
	movw R12,R16
	.dbline 277
; 
; 
; 	 text[i] = '0' + tenthousands;
	movw R30,R20
	ldd R0,y+12
	ldd R1,y+13
	add R30,R0
	adc R31,R1
	movw R24,R10
	adiw R24,48
	std z+0,R24
	.dbline 278
; 	 i++;
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 279
; 	 text[i] = '0' + thousands;
	movw R30,R20
	add R30,R0
	adc R31,R1
	movw R24,R22
	adiw R24,48
	std z+0,R24
	.dbline 280
; 	 i++;
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 281
; 	 text[i] = '0' + hundreds;
	movw R30,R20
	add R30,R0
	adc R31,R1
	movw R24,R14
	adiw R24,48
	std z+0,R24
	.dbline 282
; 	 i++;
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 283
; 	 text[i] = '0' + tens;
	movw R30,R20
	add R30,R0
	adc R31,R1
	movw R24,R12
	adiw R24,48
	std z+0,R24
	.dbline 284
; 	 i++;
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 285
; 	 text[i] = '0' + intvalue%10;
	ldi R18,10
	ldi R19,0
	ldd R16,y+10
	ldd R17,y+11
	xcall mod16s
	movw R24,R16
	adiw R24,48
	movw R30,R20
	ldd R0,y+12
	ldd R1,y+13
	add R30,R0
	adc R31,R1
	std z+0,R24
	.dbline 286
; 	 i++; 
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 287
; 	 text[i] = 0x00;
	movw R30,R20
	add R30,R0
	adc R31,R1
	clr R2
	std z+0,R2
	.dbline -2
L108:
	.dbline 0 ; func end
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym r tens 12 I
	.dbsym r hundreds 14 I
	.dbsym r thousands 22 I
	.dbsym r tenthousands 10 I
	.dbsym r i 20 I
	.dbsym l text 12 pc
	.dbsym l intvalue 10 I
	.dbend
; 	
; 
; }
; 
