/**************************************************************

   Program Title:  SmartLCD Controller
   
   Program Name:  SmartLCD_SPI.c	Version: 0.85
   
   Author:  SS	  					  Date:  August 10, 2008
   
   Compiled with ImageCraft ICCAVR Standard V7.02
   
   This file contains routines that implement an SPI Master controller
   for the SmartLCD controller.
   
   Copyright 2004-2008, SOC Robotics, Inc.  All rights reserved.
   
****************************************************************/
/*
 * Copyright 2004-2008, SOC Robotics, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 * 4. Redistribution is only allowed in combination with SOC Machines, 
 *    Inc. hardware products.
 *
 * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * For additional information see http://www.soc-robotics.com
 */

/*
 * $Log: SmartLCD_SPI.c,v $
 * Revision 0.86  2006/02/07 16:40:20  SS
 *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
 * Revision 0.52  2005/06/04 18:36:42  SS
 * Preview release
 *
 */
#include <iom168v.h>
#include <macros.h>
#include <string.h>
#include <stdlib.h>
//#include <stdio.h>
#include "SmartLCD_Uart.h"
#include "SmartLCD_Defines.h"
#include "SmartLCD_Extern.h"

//  Free SPI pins
void Release_SPI(void)
{
	// Disable SPI, Master 
	SPCR = 0x00;

 	// Set MOSI and SCK input, all others input
//	DDRB = 0x00;
	
	// Change Atmel Flash CS to input (PF2 - Port C bit 4)
	DDRC &= 0xEF;
}

// TODO - break if no reception
void SPI_MasterTransmit(unsigned char cData)
{
    long cnt;
	
	cnt = 0;
    // Start transmisstion
	SPDR = cData;
	// Wait for transmission to complete
//	puts("wait for spi tx to complete\n\r");
	while(!(SPSR & 0x80)) ;
}

// TODO - break if no reception
unsigned char SPI_MasterReceive(void)
{
    // Wait for reception to complete
	SPDR = 0x00;
	while(!(SPSR & 0x80)) ;
	
	return SPDR;
}
